<?php

/**
 * SHD SM-VIEW Cable User Status API
 *
 * @package    i-doit
 * @subpackage smview_cable
 * @author     Steve Groeber <steve.groeber@shd-online.de>
 * @copyright  SHD System-Haus-Dresden GmbH
 * @license    http://www.i-doit.com/license
 */
class cable_api_model_user_state extends cable_api_model_abstract
{

    /**
     * Name of this module.
     *
     * @var string
     */
    protected $module_name = 'user_state';

    /**
     * Name of this category.
     *
     * @var string
     */
    protected $category_name = 'C__CATG__SMVIEW_CABLE';
    
    /**
     * Constructor.
     */
    function __construct()
    {
        parent::__construct();
        $this->dao = isys_cmdb_dao_smview_cable_user_state::instance(isys_application::instance()->database);
    }

    /**
     * Create user status.
     *
     * $p_param structure:
     * array (
     *     'name'        => string,
     *     'description' => string,
     * )
     *
     * @return array
     */
    public function create($p_params)
    {
        $required_parameters = array (
            'name',
        );
        $optional_params = array(
            'description',
        );
        $data = $p_params['data'];
        return $this->_create($data, $required_parameters, $optional_params);
    }

    /**
     * Update user status.
     *
     * @param  array $p_params
     *
     * $p_param structure:
     * array (
     *     'user_state_id' => int,
     *     'name'          => string,
     *     'description'   => string,
     * )
     * @return array
     */
    public function update($p_params)
    {
        $parameters = array (
            'name',
            'description',
        );
        
        $id = $p_params['id'];
        $data = $p_params['data'];
        return $this->_update($data, $id, $parameters);
    }

    /**
     * Delete user status.
     *
     * @param array $p_params
     *
     * $p_param structure:
     * array (
     *     'user_state_id' => int,
     * )
     *
     * @return array
     */
    public function delete($p_params)
    {
        return $this->_delete('id', $p_params);
    }
}
