/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, { enumerable: true, get: getter });
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 			Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 		}
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// create a fake namespace object
/******/ 	// mode & 1: value is a module id, require it
/******/ 	// mode & 2: merge all properties of value into the ns
/******/ 	// mode & 4: return value when already ns object
/******/ 	// mode & 8|1: behave like require
/******/ 	__webpack_require__.t = function(value, mode) {
/******/ 		if(mode & 1) value = __webpack_require__(value);
/******/ 		if(mode & 8) return value;
/******/ 		if((mode & 4) && typeof value === 'object' && value && value.__esModule) return value;
/******/ 		var ns = Object.create(null);
/******/ 		__webpack_require__.r(ns);
/******/ 		Object.defineProperty(ns, 'default', { enumerable: true, value: value });
/******/ 		if(mode & 2 && typeof value != 'string') for(var key in value) __webpack_require__.d(ns, key, function(key) { return value[key]; }.bind(null, key));
/******/ 		return ns;
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 2);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


/**
 * i-doit Cable algorithm editor model class.
 *
 * @author Steve Groeber <steve.groeber@shd-online.de>
 */
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
var AlgorithmEditorModel = /*#__PURE__*/function () {
  function AlgorithmEditorModel(elements, inputId) {
    _classCallCheck(this, AlgorithmEditorModel);
    this.elements = elements;
    this.inputId = inputId;
    this.saveModelState();
  }
  _createClass(AlgorithmEditorModel, [{
    key: "getElements",
    value: function getElements() {
      return this.elements;
    }
  }, {
    key: "setElementsByMask",
    value: function setElementsByMask(mask) {
      //let separators = mask.match(/[-,\/]+/g);
      //let count = separators ? separators.length : 0;

      // add new elements
      var count = (mask.match(/#/g) || []).length;
      for (i = count; i >= 1; i--) {
        var pos = count - i + 1;
        if (this.elements[i]) {
          // update element position
          this.elements[i]['pos'] = pos;
          continue;
        }
        this.elements[i] = {
          'index': i,
          'pos': pos,
          'type': 'n',
          'length': 2
        };
      }

      // remove deleted elements
      var elementCount = Object.keys(this.elements).length;
      if (elementCount > count) {
        for (i = count + 1; i <= elementCount; i++) {
          delete this.elements[i];
        }
      }
      this.saveModelState();
    }
  }, {
    key: "setValue",
    value: function setValue(index, key, value) {
      index = parseInt(index);
      if (!this.elements[index]) {
        return;
      }
      if (key == 'pos') {
        this.handlePosUpdate(index, value);
      } else {
        this.elements[index][key] = value;
      }
      this.saveModelState();
    }
  }, {
    key: "handlePosUpdate",
    value: function handlePosUpdate(index, newPos) {
      newPos = parseInt(newPos);
      if (isNaN(newPos)) {
        // value is not a valid integer
        return;
      }
      var elementCount = Object.keys(this.elements).length;
      if (newPos < 1 || newPos > elementCount) {
        // value does not fit into range of positions
        return;
      }

      // get current position of this element
      var element = this.elements[index];
      var oldPos = element['pos'];

      // search current element on new position
      var indexOfNewPos = null;
      for (var key in this.elements) {
        if (!this.elements.hasOwnProperty(key)) {
          continue;
        }
        var e = this.elements[key];
        if (e['pos'] == newPos) {
          indexOfNewPos = key;
        }
      }

      // update this element to new position
      this.elements[index]['pos'] = newPos;

      // update the other element to old postion of this element
      if (indexOfNewPos) {
        this.elements[indexOfNewPos]['pos'] = oldPos;
      }
    }
  }, {
    key: "saveModelState",
    value: function saveModelState() {
      if ($(this.inputId)) {
        $(this.inputId).value = JSON.stringify(this.getElements());
      }
    }
  }]);
  return AlgorithmEditorModel;
}();
module.exports = AlgorithmEditorModel;

/***/ }),
/* 1 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


/**
 * i-doit Cable algorithm editor renderer class.
 *
 * @author Steve Groeber <steve.groeber@shd-online.de>
 */
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
var AlgorithmEditorRenderer = /*#__PURE__*/function () {
  function AlgorithmEditorRenderer(table, model) {
    _classCallCheck(this, AlgorithmEditorRenderer);
    var tbodys = $$('#' + table + ' tbody');
    this.tbody = tbodys[0];
    this.model = model;
  }
  _createClass(AlgorithmEditorRenderer, [{
    key: "setTranslation",
    value: function setTranslation(translation) {
      this.translation = translation;
    }
  }, {
    key: "render",
    value: function render(editMode) {
      this.edit_mode = editMode;
      var that = this;
      this.tbody.innerHTML = '';
      var elements = this.model.getElements();
      for (var key in elements) {
        if (!elements.hasOwnProperty(key)) {
          continue;
        }
        var element = elements[key];
        var tr = that.get_saved_row(element, Object.keys(elements).length);
        this.tbody.appendChild(tr);
      }
      if (!this.edit_mode) {
        return;
      }
    }
  }, {
    key: "get_saved_row",
    value: function get_saved_row(element, elementCount) {
      var that = this;
      var index = element.index;
      var tr = document.createElement('tr');
      tr.writeAttribute('id', 'row_' + index);

      // index
      var td = document.createElement('td');
      td.innerHTML = index;
      tr.appendChild(td);

      // pos
      td = document.createElement('td');
      var posInput = this._create_input('pos_' + index, element.pos);
      if (this.edit_mode) {
        posInput.writeAttribute('type', 'number');
        posInput.writeAttribute('min', 1);
        posInput.writeAttribute('max', elementCount);
        posInput.on('change', function (event) {
          // re-render table, because two positions may be changed
          that.render(that.edit_mode);
        });
      }
      td.appendChild(posInput);
      tr.appendChild(td);

      // type
      td = document.createElement('td');
      if (this.edit_mode) {
        var select = document.createElement('select');
        select.writeAttribute('id', 'type_' + index);
        var option = this._create_option('n', element.type == 'n');
        select.appendChild(option);
        option = this._create_option('e', element.type == 'e');
        select.appendChild(option);
        select.on('change', function (event) {
          var options = $(event.target).select('option:selected');
          var option = options[0];
          var parts = event.target.id.split('_');
          that.model.setValue(parts[1], parts[0], option.value);
        });
        td.appendChild(select);
      } else {
        td.innerHTML = element.type;
      }
      tr.appendChild(td);

      // description
      td = document.createElement('td');
      var descriptionInput = this._create_input('description_' + index, element.description);
      td.appendChild(descriptionInput);
      tr.appendChild(td);

      // length
      td = document.createElement('td');
      var lengthInput = this._create_input('length_' + index, element.length);
      if (this.edit_mode) {
        lengthInput.writeAttribute('type', 'number');
        lengthInput.writeAttribute('min', 1);
        lengthInput.writeAttribute('max', 8);
      }
      td.appendChild(lengthInput);
      tr.appendChild(td);

      // elements
      td = document.createElement('td');
      var elementsInput = this._create_input('elements_' + index, element.elements);
      td.appendChild(elementsInput);
      tr.appendChild(td);
      return tr;
    }
  }, {
    key: "_create_input",
    value: function _create_input(id, value) {
      var element;
      var that = this;
      value = value ? value : '';
      if (this.edit_mode) {
        element = document.createElement('input');
        element.writeAttribute('id', id);
        element.writeAttribute('value', value);
        element.addClassName('input');
        element.on('change', function (event) {
          var id = event.target.id;
          var parts = id.split('_');
          that.model.setValue(parts[1], parts[0], event.target.value);
        });
      } else {
        element = document.createElement('span');
        element.innerHTML = value;
      }
      return element;
    }
  }, {
    key: "_create_option",
    value: function _create_option(value, selected) {
      var option = document.createElement('option');
      option.writeAttribute('value', value);
      option.innerHTML = value;
      if (selected) {
        option.writeAttribute('selected', 'selected');
      }
      return option;
    }
  }]);
  return AlgorithmEditorRenderer;
}();
module.exports = AlgorithmEditorRenderer;

/***/ }),
/* 2 */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var _model_js__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(0);
/* harmony import */ var _model_js__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(_model_js__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _renderer_js__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(1);
/* harmony import */ var _renderer_js__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_renderer_js__WEBPACK_IMPORTED_MODULE_1__);


var json_elements = document.getElementById("C__CATG__SMVIEW_CABLE_ALGORITHMS").value;
var elements = json_elements ? JSON.parse(json_elements) : {};
var editMode = $('C__CATG__SMVIEW_CABLE_TITLE') ? true : false;
var model = new _model_js__WEBPACK_IMPORTED_MODULE_0___default.a(elements, 'C__CATG__SMVIEW_CABLE_ALGORITHMS');
var renderer = new _renderer_js__WEBPACK_IMPORTED_MODULE_1___default.a('algorithms_tab', model);
var translation = idoit.Translate || new Hash();
renderer.render(editMode);
if (document.getElementById('C__CATG__SMVIEW_CABLE_MASK')) {
  document.getElementById('C__CATG__SMVIEW_CABLE_MASK').on('keyup', function () {
    var mask = document.getElementById('C__CATG__SMVIEW_CABLE_MASK').value;
    model.setElementsByMask(mask);
    renderer.render(true);
  });
}

/***/ })
/******/ ]);