/******/ (function() { // webpackBootstrap
/******/ 	"use strict";
/******/ 	var __webpack_modules__ = ({

/***/ "rFdI":
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {


var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.AlgorithmEditorCompose = void 0;
var React = __webpack_require__("q1tI");
var AlgorithmEditorCompose = /** @class */ (function (_super) {
    __extends(AlgorithmEditorCompose, _super);
    function AlgorithmEditorCompose(props) {
        var _this = _super.call(this, props) || this;
        var generator = _this.props.generator && Object.keys(_this.props.generator).length > 0 ? _this.props.generator : {
            title: '',
            description: '',
            mask: '',
            counter_min: 1,
            counter_max: 1,
            algorithm_items: [],
        };
        _this.state = {
            generator: generator,
        };
        _this.handleGeneratorChange = _this.handleGeneratorChange.bind(_this);
        _this.handleAlgorithmItemChange = _this.handleAlgorithmItemChange.bind(_this);
        _this._saveGenerator = _this._saveGenerator.bind(_this);
        return _this;
    }
    AlgorithmEditorCompose.prototype.setElementsByMask = function (mask) {
        var count = (mask.match(/#/g) || []).length;
        var elements = this.state.generator.algorithm_items;
        var new_elements = [];
        for (var i = count - 1; i >= 0; i--) {
            var pos = count - i;
            if (elements[i]) {
                // update element position
                var e = elements[i];
                e.pos = pos;
                new_elements.push(e);
            }
            else {
                // add new element
                new_elements.push({
                    index: i + 1,
                    pos: pos,
                    type: 'n',
                    length: 2,
                    description: '',
                    elements: ''
                });
            }
        }
        var generator = this.state.generator;
        generator.algorithm_items = new_elements;
        this._saveGenerator(generator);
    };
    AlgorithmEditorCompose.prototype.handlePosUpdate = function (index, newPos1) {
        var newPos = parseInt(newPos1);
        if (isNaN(newPos)) {
            // value is not a valid integer
            return;
        }
        var generator = this.state.generator;
        var elementCount = generator.algorithm_items.length;
        if (newPos < 1 || newPos > elementCount) {
            // value does not fit into range of positions
            return;
        }
        // get current position of this element
        var elementsPosCurrent = generator.algorithm_items.filter(function (e) { return e.index == index; });
        var oldPos = elementsPosCurrent ? elementsPosCurrent[0].pos : null;
        // search current element on new position
        var elementsPosNew = generator.algorithm_items.filter(function (e) { return e.pos == newPos; });
        var indexOfNewPos = elementsPosNew ? elementsPosNew[0].index : null;
        // update positions
        var items = [];
        generator.algorithm_items.forEach(function (item) {
            if (item.index == index) {
                item.pos = newPos;
            }
            if (item.index == indexOfNewPos) {
                item.pos = oldPos;
            }
            items.push(item);
        });
        generator.algorithm_items = items;
        this._saveGenerator(generator);
    };
    AlgorithmEditorCompose.prototype.handleGeneratorChange = function (e) {
        var _a;
        var id = e.currentTarget.id;
        var generator = this.state.generator;
        if (id == 'mask') {
            this.setElementsByMask(e.currentTarget.value);
        }
        Object.assign(generator, (_a = {}, _a[id] = e.currentTarget.value, _a));
        this._saveGenerator(generator);
    };
    AlgorithmEditorCompose.prototype.handleAlgorithmItemChange = function (e) {
        var _this = this;
        var generator = this.state.generator;
        var parts = e.currentTarget.id.split('_');
        var index = parseInt(parts[1]);
        var property = parts[0];
        var updatedItems = [];
        generator.algorithm_items.forEach(function (item) {
            var _a;
            if (item.index == index) {
                if (property == 'pos') {
                    _this.handlePosUpdate(index, e.currentTarget.value);
                }
                else {
                    Object.assign(item, (_a = {}, _a[property] = e.currentTarget.value, _a));
                }
            }
            updatedItems.push(item);
        });
        generator.algorithm_items = updatedItems;
        this._saveGenerator(generator);
    };
    AlgorithmEditorCompose.prototype._saveGenerator = function (generator) {
        var _this = this;
        this.setState(function (prevState) { return (__assign(__assign({}, prevState), { generator: generator })); }, function () {
            // save json to DOM
            var json = JSON.stringify(_this.state.generator);
            document.getElementById('C__CATG__SMVIEW_CABLE_GENERATOR').setAttribute('value', json);
        });
    };
    AlgorithmEditorCompose.prototype.renderInputRow = function (identifier, label, value) {
        return React.createElement("tr", null,
            React.createElement("td", { className: "key" }, label),
            React.createElement("td", { className: "value" },
                React.createElement("div", { className: "ml20" },
                    React.createElement("input", { id: identifier, className: "input", value: value, disabled: !this.props.is_editable, onChange: this.handleGeneratorChange }))));
    };
    AlgorithmEditorCompose.prototype.renderAlgorithmItemRow = function (i) {
        return React.createElement("tr", { id: i.index.toString(), key: i.index.toString() },
            React.createElement("td", null, i.index),
            React.createElement("td", null,
                React.createElement("input", { id: 'pos_' + i.index, className: "input", value: i.pos, disabled: !this.props.is_editable, onChange: this.handleAlgorithmItemChange, type: "number", min: 1, max: Object.keys(this.state.generator.algorithm_items).length })),
            React.createElement("td", null,
                React.createElement("select", { id: 'type_' + i.index, className: "input input-small", value: i.type, disabled: !this.props.is_editable, onChange: this.handleAlgorithmItemChange },
                    React.createElement("option", { value: "n" }, "n"),
                    React.createElement("option", { value: "e" }, "e"))),
            React.createElement("td", null,
                React.createElement("input", { id: 'description_' + i.index, className: "input", value: i.description, disabled: !this.props.is_editable, onChange: this.handleAlgorithmItemChange })),
            React.createElement("td", null,
                React.createElement("input", { id: 'length_' + i.index, className: "input", value: i.length, disabled: !this.props.is_editable, onChange: this.handleAlgorithmItemChange, type: "number", min: 1, max: 8 })),
            React.createElement("td", null,
                React.createElement("input", { id: 'elements_' + i.index, className: "input", value: i.elements, disabled: !this.props.is_editable, onChange: this.handleAlgorithmItemChange })));
    };
    AlgorithmEditorCompose.prototype.render = function () {
        var _this = this;
        var language = this.props.language;
        var generator = this.state.generator;
        var rows = [];
        if (generator.algorithm_items) {
            // sort by index
            var items = generator.algorithm_items.sort(function (a, b) { return a.index > b.index ? 1 : -1; });
            items.forEach(function (i) {
                rows.push(_this.renderAlgorithmItemRow(i));
            });
        }
        return React.createElement("table", { className: "contentTable", id: "algorithm_generator" },
            React.createElement("tbody", null,
                this.renderInputRow('title', language.LC__CMDB__CATG__SMVIEW_CABLE__GENERATOR_TITLE, generator.title),
                this.renderInputRow('description', language.LC__CMDB__CATG__SMVIEW_CABLE__GENERATOR_DESCRIPTION, generator.description),
                this.renderInputRow('mask', language.LC__CMDB__CATG__SMVIEW_CABLE__GENERATOR_MASK, generator.mask),
                this.renderInputRow('counter_min', language.LC__CMDB__CATG__SMVIEW_CABLE__GENERATOR_COUNTER_MIN, generator.counter_min.toString()),
                this.renderInputRow('counter_max', language.LC__CMDB__CATG__SMVIEW_CABLE__GENERATOR_COUNTER_MAX, generator.counter_max.toString()),
                React.createElement("tr", null,
                    React.createElement("td", { className: "key" }, language.LC__CMDB__CATG__SMVIEW_CABLE__GENERATOR_ALGORITHMS),
                    React.createElement("td", { className: "value" },
                        React.createElement("div", { id: "algorithms" },
                            React.createElement("table", { id: 'algorithms_tab' },
                                React.createElement("thead", null,
                                    React.createElement("tr", null,
                                        React.createElement("th", null, language.LC__CMDB__CATG__SMVIEW_CABLE__GENERATOR_ALGORITHM_INDEX),
                                        React.createElement("th", null, language.LC__CMDB__CATG__SMVIEW_CABLE__GENERATOR_ALGORITHM_MASK_POSITION),
                                        React.createElement("th", null, language.LC__CMDB__CATG__SMVIEW_CABLE__GENERATOR_ALGORITHM_TYPE),
                                        React.createElement("th", null, language.LC__CMDB__CATG__SMVIEW_CABLE__GENERATOR_DESCRIPTION),
                                        React.createElement("th", null, language.LC__CMDB__CATG__SMVIEW_CABLE__GENERATOR_ALGORITHM_LENGTH),
                                        React.createElement("th", null, language.LC__CMDB__CATG__SMVIEW_CABLE__GENERATOR_ALGORITHM_ELEMENTS))),
                                React.createElement("tbody", null, rows)))))));
    };
    return AlgorithmEditorCompose;
}(React.Component));
exports.AlgorithmEditorCompose = AlgorithmEditorCompose;


/***/ }),

/***/ "U9vE":
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {


var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
__webpack_require__("DxgT");
var React = __webpack_require__("q1tI");
var ReactDOM = __webpack_require__("i8i4");
var AlgorithmEditorCompose_1 = __webpack_require__("rFdI");
var config = document.getElementById('C__CATG__SMVIEW_REACT_CONFIG').getAttribute('value');
var element = document.getElementById('navbar_item_C__NAVMODE__SAVE');
var is_editable = element != null;
if (config) {
    var cfg = JSON.parse(config);
    ReactDOM.render(React.createElement(AlgorithmEditorCompose_1.AlgorithmEditorCompose, __assign({ is_editable: is_editable }, cfg)), document.getElementById('editor'));
}


/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			// no module.id needed
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = __webpack_modules__;
/******/ 	
/************************************************************************/
/******/ 	/* webpack/runtime/chunk loaded */
/******/ 	!function() {
/******/ 		var deferred = [];
/******/ 		__webpack_require__.O = function(result, chunkIds, fn, priority) {
/******/ 			if(chunkIds) {
/******/ 				priority = priority || 0;
/******/ 				for(var i = deferred.length; i > 0 && deferred[i - 1][2] > priority; i--) deferred[i] = deferred[i - 1];
/******/ 				deferred[i] = [chunkIds, fn, priority];
/******/ 				return;
/******/ 			}
/******/ 			var notFulfilled = Infinity;
/******/ 			for (var i = 0; i < deferred.length; i++) {
/******/ 				var chunkIds = deferred[i][0];
/******/ 				var fn = deferred[i][1];
/******/ 				var priority = deferred[i][2];
/******/ 				var fulfilled = true;
/******/ 				for (var j = 0; j < chunkIds.length; j++) {
/******/ 					if ((priority & 1 === 0 || notFulfilled >= priority) && Object.keys(__webpack_require__.O).every(function(key) { return __webpack_require__.O[key](chunkIds[j]); })) {
/******/ 						chunkIds.splice(j--, 1);
/******/ 					} else {
/******/ 						fulfilled = false;
/******/ 						if(priority < notFulfilled) notFulfilled = priority;
/******/ 					}
/******/ 				}
/******/ 				if(fulfilled) {
/******/ 					deferred.splice(i--, 1)
/******/ 					var r = fn();
/******/ 					if (r !== undefined) result = r;
/******/ 				}
/******/ 			}
/******/ 			return result;
/******/ 		};
/******/ 	}();
/******/ 	
/******/ 	/* webpack/runtime/global */
/******/ 	!function() {
/******/ 		__webpack_require__.g = (function() {
/******/ 			if (typeof globalThis === 'object') return globalThis;
/******/ 			try {
/******/ 				return this || new Function('return this')();
/******/ 			} catch (e) {
/******/ 				if (typeof window === 'object') return window;
/******/ 			}
/******/ 		})();
/******/ 	}();
/******/ 	
/******/ 	/* webpack/runtime/hasOwnProperty shorthand */
/******/ 	!function() {
/******/ 		__webpack_require__.o = function(obj, prop) { return Object.prototype.hasOwnProperty.call(obj, prop); }
/******/ 	}();
/******/ 	
/******/ 	/* webpack/runtime/jsonp chunk loading */
/******/ 	!function() {
/******/ 		// no baseURI
/******/ 		
/******/ 		// object to store loaded and loading chunks
/******/ 		// undefined = chunk not loaded, null = chunk preloaded/prefetched
/******/ 		// [resolve, reject, Promise] = chunk loading, 0 = chunk loaded
/******/ 		var installedChunks = {
/******/ 			"algorithm_editor": 0
/******/ 		};
/******/ 		
/******/ 		// no chunk on demand loading
/******/ 		
/******/ 		// no prefetching
/******/ 		
/******/ 		// no preloaded
/******/ 		
/******/ 		// no HMR
/******/ 		
/******/ 		// no HMR manifest
/******/ 		
/******/ 		__webpack_require__.O.j = function(chunkId) { return installedChunks[chunkId] === 0; };
/******/ 		
/******/ 		// install a JSONP callback for chunk loading
/******/ 		var webpackJsonpCallback = function(parentChunkLoadingFunction, data) {
/******/ 			var chunkIds = data[0];
/******/ 			var moreModules = data[1];
/******/ 			var runtime = data[2];
/******/ 			// add "moreModules" to the modules object,
/******/ 			// then flag all "chunkIds" as loaded and fire callback
/******/ 			var moduleId, chunkId, i = 0;
/******/ 			if(chunkIds.some(function(id) { return installedChunks[id] !== 0; })) {
/******/ 				for(moduleId in moreModules) {
/******/ 					if(__webpack_require__.o(moreModules, moduleId)) {
/******/ 						__webpack_require__.m[moduleId] = moreModules[moduleId];
/******/ 					}
/******/ 				}
/******/ 				if(runtime) var result = runtime(__webpack_require__);
/******/ 			}
/******/ 			if(parentChunkLoadingFunction) parentChunkLoadingFunction(data);
/******/ 			for(;i < chunkIds.length; i++) {
/******/ 				chunkId = chunkIds[i];
/******/ 				if(__webpack_require__.o(installedChunks, chunkId) && installedChunks[chunkId]) {
/******/ 					installedChunks[chunkId][0]();
/******/ 				}
/******/ 				installedChunks[chunkId] = 0;
/******/ 			}
/******/ 			return __webpack_require__.O(result);
/******/ 		}
/******/ 		
/******/ 		var chunkLoadingGlobal = self["webpackChunksmview_cable_etsi_management"] = self["webpackChunksmview_cable_etsi_management"] || [];
/******/ 		chunkLoadingGlobal.forEach(webpackJsonpCallback.bind(null, 0));
/******/ 		chunkLoadingGlobal.push = webpackJsonpCallback.bind(null, chunkLoadingGlobal.push.bind(chunkLoadingGlobal));
/******/ 	}();
/******/ 	
/************************************************************************/
/******/ 	
/******/ 	// startup
/******/ 	// Load entry module and return exports
/******/ 	// This entry module depends on other loaded chunks and execution need to be delayed
/******/ 	var __webpack_exports__ = __webpack_require__.O(undefined, ["vendors"], function() { return __webpack_require__("U9vE"); })
/******/ 	__webpack_exports__ = __webpack_require__.O(__webpack_exports__);
/******/ 	
/******/ })()
;