import * as React from 'react'
import { Layout } from '../Layout'
const ReactTestRenderer = require('react-test-renderer')
const mockFunction = jest.fn()

it('renders readonly layout correctly', () => {
  const component = ReactTestRenderer.create(
    <Layout is_editable={false} layout='1' onLayoutChange={mockFunction} />
  )
  expect(component).toMatchSnapshot()
})

it('renders layout one correctly', () => {
  const component = ReactTestRenderer.create(
    <Layout is_editable={true} layout='1' onLayoutChange={mockFunction} />
  )
  expect(component).toMatchSnapshot()

  const instance = component.root
  const div = instance.findByProps({ value: '1' })
  div.props.onChange({
    currentTarget: { value: '1' }
  })
  expect(mockFunction).toHaveBeenCalledWith('layout', '1')
})

it('renders layout two correctly', () => {
  const component = ReactTestRenderer.create(
    <Layout is_editable={true} layout='2' onLayoutChange={mockFunction} />
  )
  expect(component).toMatchSnapshot()
})

it('renders layout three correctly', () => {
  const component = ReactTestRenderer.create(
    <Layout is_editable={true} layout='3' onLayoutChange={mockFunction} />
  )
  expect(component).toMatchSnapshot()
})

it('renders layout four correctly', () => {
  const component = ReactTestRenderer.create(
    <Layout is_editable={true} layout='4' onLayoutChange={mockFunction} />
  )
  expect(component).toMatchSnapshot()
})
