import * as React from 'react'
import {LastRow} from "../../Row/LastRow";
const ReactTestRenderer = require('react-test-renderer')

const last_index = 2
const selectable_objects = [
    {
        cable_id: 100,
        cable_title: 'Cable01',
        length: 1000,
        wire_id: 1001,
        wire_title: 'Wire02',
        wire_scope: 'B1',
        wire_pin_in_title: 'PinIn01',
        wire_pin_out_title: 'PinOut01',
        section_id: 0,
        section_title: '',
        cable_free_wires: 2,
        cable_patched_wires: 6,
        cable_max_capacity: 80,
        obj_in_id: 200,
        obj_in_title: 'ObjIn01',
        pin_in_id: 300,
        pin_in_title: 'PinIn01',
        pin_in_scope: 'P1',
        obj_out_id: 201,
        obj_out_title: 'ObjOut01',
        pin_out_id: 301,
        pin_out_title: 'PinOut01',
        pin_out_scope: 'P1',
    }
]

const last_element = {
    id: 1,
    title: 'obj01'
}

const cableSelectionChangeMockFunction = jest.fn()

it('renders last row correctly', () => {
    const component = ReactTestRenderer.create(
        <LastRow is_loading={false}
                 is_route={true}
                 spinner_url={''}
                 last_index={last_index}
                 selectable_objects={selectable_objects}
                 last_element={last_element}
                 onCableSelectionChange={cableSelectionChangeMockFunction} />
    )
    expect(component).toMatchSnapshot()

    const instance = component.root
    const select = instance.findByProps({ id: 'cable_3' })
    select.props.onChange({
        currentTarget: {
            id: 'cable_3',
            value: 'w_1000'
        }
    })
    expect(cableSelectionChangeMockFunction).toHaveBeenCalledWith(3, 1000, null)

    select.props.onChange({
        currentTarget: {
            id: 'cable_3',
            value: 's_800'
        }
    })
    expect(cableSelectionChangeMockFunction).toHaveBeenCalledWith(3, null, 800)
})
