const ExtractTextPlugin = require('extract-text-webpack-plugin');
const CopyWebpackPlugin = require('copy-webpack-plugin');

module.exports = {
  entry: {
      algorithm: './js/src/algorithm_editor/index.js'
  },
  output: {
    filename: '[name]-bundle.js'
  },
  module: {
    rules: [
      // babel options
      {
        test: /\.js$/,
        exclude: [/node_modules/],
        use: {
          loader: 'babel-loader',
          options: {
            presets: ['@babel/preset-env']
          }
        }
      },
      // sass to css file
        {
          test: /\.(scss)$/,
          loader: ExtractTextPlugin.extract(['css-loader', 'sass-loader'])
        }
    ]
  },
  optimization: {
     minimize: false
   },
  plugins: [
    new ExtractTextPlugin('css/style.css'),
    new CopyWebpackPlugin([
        {from: 'css', to: 'css'}
    ])
  ]
};
