<?php

use idoit\Component\Property\LegacyPropertyInterface;
use idoit\Component\Property\Type\ObjectBrowserProperty;
use idoit\Component\Property\Type\TextProperty;

/**
 * i-doit
 *
 * DAO: global category for SM-VIEW Cable Assigned Stations.
 *
 * @package    i-doit
 * @subpackage smview_cable
 * @author     Steve Groeber <steve.groeber@shd-online.de>
 * @copyright  2023 SHD System-Haus-Dresden GmbH
 * @license    http://www.i-doit.com/license
 */
class isys_cmdb_dao_category_g_smview_cable_assigned_stations extends isys_cmdb_dao_category_global
{

    /**
     * Category's name. Will be used for the identifier, constant, main table, and many more.
     *
     * @var string
     */
    protected $m_category = 'smview_cable_assigned_stations';

    /**
     * Is category multi-valued or single-valued?
     *
     * @var boolean
     */
    protected $m_multivalued = true;

    /**
     * Method for returning the properties.
     *
     * @return array
     */
    protected function properties()
    {
        return [
            'description' => (new TextProperty(
                'C__CATG__SMVIEW_CABLE_DESCRIPTION',
                'LC__UNIVERSAL__DESCRIPTION',
                'isys_catg_smview_cable_assigned_stations_list__description',
                'isys_catg_smview_cable_assigned_stations_list'
            ))->mergePropertyUiParams([
                'p_strClass'  => 'input',
            ]),
            'station_id' => (new ObjectBrowserProperty(
                'C__CATG__SMVIEW_CABLE_STATION_ID',
                'LC__SHD__STATION',
                'isys_catg_smview_cable_assigned_stations_list__station_id',
                'isys_catg_smview_cable_assigned_stations_list',
            ))->mergePropertyUiParams([
                isys_popup_browser_object_ng::C__MULTISELECTION => false
            ])->setPropertyCheck([
                LegacyPropertyInterface::C__PROPERTY__CHECK__MANDATORY => true
            ])
        ];
    }
}
