<?php

use idoit\Component\Property\Type\DialogPlusProperty;
use idoit\Component\Property\Type\IntProperty;
use idoit\Component\Property\Type\TextProperty;

/**
 * i-doit
 *
 * DAO: global category for SM-VIEW Cable Extended Location.
 *
 * @package    i-doit
 * @subpackage smview_cable
 * @author     Steve Groeber <steve.groeber@shd-online.de>
 * @copyright  2022 SHD System-Haus-Dresden GmbH
 * @license    http://www.i-doit.com/license
 */
class isys_cmdb_dao_category_g_smview_cable_extended_location extends isys_cmdb_dao_category_global
{

    /**
     * Category's name. Will be used for the identifier, constant, main table, and many more.
     *
     * @var string
     */
    protected $m_category = 'smview_cable_extended_location';

    /**
     * Is category multi-valued or single-valued?
     *
     * @var boolean
     */
    protected $m_multivalued = false;

    /**
     * Method for returning the properties.
     *
     * @return array
     */
    protected function properties()
    {
        return [
            'description' => (new TextProperty(
                'C__CATG__SMVIEW_CABLE_EXTENDED_LOCATION_DESCRIPTION',
                'LC__CMDB__CATG__DESCRIPTION',
                'isys_catg_smview_cable_extended_location_list__description',
                'isys_catg_smview_cable_extended_location_list'
            )),
            'location' => (new DialogPlusProperty(
                'C__CATG__SMVIEW_CABLE_EXTENDED_LOCATION_LOCATION',
                'LC__CMDB__CATG__SMVIEW_CABLE__EXTENDED_LOCATION',
                'isys_catg_smview_cable_extended_location_list__location_id',
                'isys_catg_smview_cable_extended_location_list',
                'isys_shd_extended_location'
            ))->mergePropertyUiParams(
                [
                    'p_strClass' => 'input',
                ]
            ),
            'position' => (new IntProperty(
                'C__CATG__SMVIEW_CABLE_EXTENDED_LOCATION_POSITION',
                'LC__CMDB__CATG__SMVIEW_CABLE__EXTENDED_LOCATION_POSITION',
                'isys_catg_smview_cable_extended_location_list__position',
                'isys_catg_smview_cable_extended_location_list'
            )),
        ];
    }
}
