<?php

/**
 * i-doit
 *
 * DAO: global category for SM-VIEW Cable routes.
 *
 * @package    i-doit
 * @subpackage smview_cable
 * @author     Steve Groeber <steve.groeber@shd-online.de>
 * @copyright  SHD System-Haus-Dresden GmbH
 * @license    http://www.i-doit.com/license
 */
class isys_cmdb_dao_category_g_smview_cable_route extends isys_cmdb_dao_category_global
{

    /**
     * Category's name. Will be used for the identifier, constant, main table, and many more.
     *
     * @var string
     */
    protected $m_category = 'smview_cable_route';

    /**
     * Is category multi-valued or single-valued?
     *
     * @var boolean
     */
    protected $m_multivalued = false;

    /**
     * Method for returning the properties.
     *
     * @return array
     * @author Leonard Fischer <lfischer@i-doit.org>
     */
    protected function properties()
    {
        return [
            'description' => array_replace_recursive(
                isys_cmdb_dao_category_pattern::text(),
                [
                    C__PROPERTY__INFO => [
                        C__PROPERTY__INFO__TITLE => 'LC__CMDB__CATG__SMVIEW_CABLE__DESCRIPTION',
                        C__PROPERTY__INFO__DESCRIPTION => 'Description'
                    ],
                    C__PROPERTY__DATA => [
                        C__PROPERTY__DATA__FIELD => 'isys_catg_smview_cable_route_list__description'
                    ],
                    C__PROPERTY__UI => [
                        C__PROPERTY__UI__ID => 'C__CATG__SMVIEW_CABLE_DESCRIPTION'
                    ]
                ]
            ),
            'connection_count' => array_replace_recursive(
                isys_cmdb_dao_category_pattern::int(),
                [
                    C__PROPERTY__INFO => [
                        C__PROPERTY__INFO__TITLE => 'LC__CMDB__CATG__SMVIEW_CABLE__CONNECTION_COUNT',
                        C__PROPERTY__INFO__DESCRIPTION => 'Number'
                    ],
                    C__PROPERTY__DATA => [
                        C__PROPERTY__DATA__FIELD => 'isys_catg_smview_cable_route_list__connection_count'
                    ],
                    C__PROPERTY__UI => [
                        C__PROPERTY__UI__ID => 'C__CATG__SMVIEW_CABLE_CONNECTION_COUNT',
                        C__PROPERTY__UI__PARAMS => [
                            'p_strClass' => 'input-small'
                        ]
                    ]
                ]
            ),
            'current_connection_count' => array_replace_recursive(
                isys_cmdb_dao_category_pattern::int(),
                [
                    C__PROPERTY__INFO => [
                        C__PROPERTY__INFO__TITLE => 'LC__CMDB__CATG__SMVIEW_CABLE__CURRENT_CONNECTION_COUNT',
                        C__PROPERTY__INFO__DESCRIPTION => 'Number'
                    ],
                    C__PROPERTY__DATA => [
                        C__PROPERTY__DATA__FIELD => 'isys_catg_smview_cable_route_list__current_connection_count'
                    ],
                    C__PROPERTY__UI => [
                        C__PROPERTY__UI__ID => 'C__CATG__SMVIEW_CABLE_CURRENT_CONNECTION_COUNT',
                        C__PROPERTY__UI__PARAMS => [
                            'p_strClass' => 'input-small'
                        ]
                    ]
                ]
            ),
            'permission' => array_replace_recursive(
                isys_cmdb_dao_category_pattern::text(),
                [
                    C__PROPERTY__INFO => [
                        C__PROPERTY__INFO__TITLE => 'LC__CMDB__CATG__SMVIEW_CABLE__ROUTE_PERMISSION',
                        C__PROPERTY__INFO__DESCRIPTION => 'Permission'
                    ],
                    C__PROPERTY__DATA => [
                        C__PROPERTY__DATA__FIELD => 'isys_catg_smview_cable_route_list__permission'
                    ],
                    C__PROPERTY__UI => [
                        C__PROPERTY__UI__ID => 'C__CATG__SMVIEW_CABLE_PERMISSION'
                    ]
                ]
            ),
            'location' => array_replace_recursive(
                isys_cmdb_dao_category_pattern::text(),
                [
                    C__PROPERTY__INFO => [
                        C__PROPERTY__INFO__TITLE => 'LC__CMDB__CATG__SMVIEW_CABLE__ROUTE_LOCATION',
                        C__PROPERTY__INFO__DESCRIPTION => 'Location'
                    ],
                    C__PROPERTY__DATA => [
                        C__PROPERTY__DATA__FIELD => 'isys_catg_smview_cable_route_list__location'
                    ],
                    C__PROPERTY__UI => [
                        C__PROPERTY__UI__ID => 'C__CATG__SMVIEW_CABLE_LOCATION'
                    ]
                ]
            ),
            'room' => array_replace_recursive(
                isys_cmdb_dao_category_pattern::text(),
                [
                    C__PROPERTY__INFO => [
                        C__PROPERTY__INFO__TITLE => 'LC__CMDB__CATG__SMVIEW_CABLE__ROUTE_ROOM',
                        C__PROPERTY__INFO__DESCRIPTION => 'Room'
                    ],
                    C__PROPERTY__DATA => [
                        C__PROPERTY__DATA__FIELD => 'isys_catg_smview_cable_route_list__room'
                    ],
                    C__PROPERTY__UI => [
                        C__PROPERTY__UI__ID => 'C__CATG__SMVIEW_CABLE_ROOM'
                    ]
                ]
            ),
            'device_type' => array_replace_recursive(
                isys_cmdb_dao_category_pattern::text(),
                [
                    C__PROPERTY__INFO => [
                        C__PROPERTY__INFO__TITLE => 'LC__CMDB__CATG__SMVIEW_CABLE__ROUTE_DEVICE_TYPE',
                        C__PROPERTY__INFO__DESCRIPTION => 'Device Type'
                    ],
                    C__PROPERTY__DATA => [
                        C__PROPERTY__DATA__FIELD => 'isys_catg_smview_cable_route_list__device_type'
                    ],
                    C__PROPERTY__UI => [
                        C__PROPERTY__UI__ID => 'C__CATG__SMVIEW_CABLE_DEVICE_TYPE'
                    ]
                ]
            ),
            'device_number' => array_replace_recursive(
                isys_cmdb_dao_category_pattern::text(),
                [
                    C__PROPERTY__INFO => [
                        C__PROPERTY__INFO__TITLE => 'LC__CMDB__CATG__SMVIEW_CABLE__ROUTE_DEVICE_NUMBER',
                        C__PROPERTY__INFO__DESCRIPTION => 'Device Number'
                    ],
                    C__PROPERTY__DATA => [
                        C__PROPERTY__DATA__FIELD => 'isys_catg_smview_cable_route_list__device_number'
                    ],
                    C__PROPERTY__UI => [
                        C__PROPERTY__UI__ID => 'C__CATG__SMVIEW_CABLE_DEVICE_NUMBER'
                    ]
                ]
            ),
            'phone_number' => array_replace_recursive(
                isys_cmdb_dao_category_pattern::text(),
                [
                    C__PROPERTY__INFO => [
                        C__PROPERTY__INFO__TITLE => 'LC__CMDB__CATG__SMVIEW_CABLE__ROUTE_PHONE_NUMBER',
                        C__PROPERTY__INFO__DESCRIPTION => 'Phone Number'
                    ],
                    C__PROPERTY__DATA => [
                        C__PROPERTY__DATA__FIELD => 'isys_catg_smview_cable_route_list__phone_number'
                    ],
                    C__PROPERTY__UI => [
                        C__PROPERTY__UI__ID => 'C__CATG__SMVIEW_CABLE_PHONE_NUMBER'
                    ]
                ]
            ),
            'route_usage_id' => array_replace_recursive(
                isys_cmdb_dao_category_pattern::dialog(),
                [
                    C__PROPERTY__INFO => [
                        C__PROPERTY__INFO__TITLE => 'LC__CMDB__CATG__SMVIEW_CABLE__ROUTE_USAGE',
                        C__PROPERTY__INFO__DESCRIPTION => 'Route Usage'
                    ],
                    C__PROPERTY__DATA => [
                        C__PROPERTY__DATA__FIELD => 'isys_catg_smview_cable_route_list__route_usage_id',
                        C__PROPERTY__DATA__SOURCE_TABLE => 'isys_catg_smview_cable_route_usage',
                        C__PROPERTY__DATA__REFERENCES   => [
                            'isys_catg_smview_cable_route_usage',
                            'isys_catg_smview_cable_route_usage__id'
                        ],
                        C__PROPERTY__DATA__SELECT => idoit\Module\Report\SqlQuery\Structure\SelectSubSelect::factory(
                            'SELECT g.isys_catg_smview_cable_route_usage__name
                        FROM isys_catg_smview_cable_route_usage g
                        INNER JOIN isys_catg_smview_cable_route_list l ON g.isys_catg_smview_cable_route_usage__id = l.isys_catg_smview_cable_route_list__route_usage_id',
                            'isys_catg_smview_cable_route_list',
                            'isys_catg_smview_cable_route_list__id',
                            'isys_catg_smview_cable_route_list__isys_obj__id'
                        )
                    ],
                    C__PROPERTY__UI => [
                        C__PROPERTY__UI__ID => 'C__CATG__SMVIEW_CABLE_ROUTE_USAGE',
                        C__PROPERTY__UI__PARAMS => [
                            'p_arData' => new isys_callback(
                                [
                                    'isys_cmdb_dao_category_g_smview_cable_route',
                                    'callback_property_route_usages'
                                ]
                            )
                        ]
                    ]
                ]
            ),
            'phone_subscriber' => array_replace_recursive(
                isys_cmdb_dao_category_pattern::text(),
                [
                    C__PROPERTY__INFO => [
                        C__PROPERTY__INFO__TITLE => 'LC__CMDB__CATG__SMVIEW_CABLE__ROUTE_PHONE_SUBSCRIBER',
                        C__PROPERTY__INFO__DESCRIPTION => 'Phone Subscriber'
                    ],
                    C__PROPERTY__DATA => [
                        C__PROPERTY__DATA__FIELD => 'isys_catg_smview_cable_route_list__phone_subscriber'
                    ],
                    C__PROPERTY__UI => [
                        C__PROPERTY__UI__ID => 'C__CATG__SMVIEW_CABLE_PHONE_SUBSCRIBER'
                    ]
                ]
            ),
            'hint' => array_replace_recursive(
                isys_cmdb_dao_category_pattern::text(),
                [
                    C__PROPERTY__INFO => [
                        C__PROPERTY__INFO__TITLE => 'LC__CMDB__CATG__SMVIEW_CABLE__ROUTE_HINT',
                        C__PROPERTY__INFO__DESCRIPTION => 'Hint'
                    ],
                    C__PROPERTY__DATA => [
                        C__PROPERTY__DATA__FIELD => 'isys_catg_smview_cable_route_list__hint'
                    ],
                    C__PROPERTY__UI => [
                        C__PROPERTY__UI__ID => 'C__CATG__SMVIEW_CABLE_HINT'
                    ]
                ]
            ),
            'length' => array_replace_recursive(
                isys_cmdb_dao_category_pattern::int(),
                [
                    C__PROPERTY__INFO => [
                        C__PROPERTY__INFO__TITLE => 'LC__CMDB__CATG__SMVIEW_CABLE__ROUTE_LENGTH',
                        C__PROPERTY__INFO__DESCRIPTION => 'Length'
                    ],
                    C__PROPERTY__DATA => [
                        C__PROPERTY__DATA__FIELD => 'isys_catg_smview_cable_route_list__length'
                    ],
                    C__PROPERTY__UI => [
                        C__PROPERTY__UI__ID => 'C__CATG__SMVIEW_CABLE_ROUTE_LENGTH',
                        C__PROPERTY__UI__PARAMS => [
                            'p_bReadonly' => 1,
                            'p_strClass'  => 'input-small'
                        ]
                    ]
                ]
            ),
            'measured_length' => array_replace_recursive(
                isys_cmdb_dao_category_pattern::int(),
                [
                    C__PROPERTY__INFO => [
                        C__PROPERTY__INFO__TITLE => 'LC__CMDB__CATG__SMVIEW_CABLE__ROUTE_MEASURED_LENGTH',
                        C__PROPERTY__INFO__DESCRIPTION => 'Measured Length'
                    ],
                    C__PROPERTY__DATA => [
                        C__PROPERTY__DATA__FIELD => 'isys_catg_smview_cable_route_list__measured_length'
                    ],
                    C__PROPERTY__UI => [
                        C__PROPERTY__UI__ID => 'C__CATG__SMVIEW_CABLE_ROUTE_MEASURED_LENGTH',
                        C__PROPERTY__UI__PARAMS => [
                            'p_strClass'  => 'input-small'
                        ]
                    ]
                ]
            ),
            'measure_date' => array_replace_recursive(
                isys_cmdb_dao_category_pattern::date(),
                [
                    C__PROPERTY__INFO => [
                        C__PROPERTY__INFO__TITLE => 'LC__CMDB__CATG__SMVIEW_CABLE__ROUTE_MEASURE_DATE',
                        C__PROPERTY__INFO__DESCRIPTION => 'Measure Date'
                    ],
                    C__PROPERTY__DATA => [
                        C__PROPERTY__DATA__FIELD => 'isys_catg_smview_cable_route_list__measure_date'
                    ],
                    C__PROPERTY__UI => [
                        C__PROPERTY__UI__ID => 'C__CATG__SMVIEW_CABLE_MEASURE_DATE',
                        C__PROPERTY__UI__PARAMS => [
                            'p_strPopupType'   => 'calendar',
                            'p_bTime'          => 0,
                            'p_strPlaceholder' => 'dd.mm.yyyy',
                        ]
                    ]
                ]
            ),
            'tka_participant' => array_replace_recursive(
                isys_cmdb_dao_category_pattern::text(),
                [
                    C__PROPERTY__INFO => [
                        C__PROPERTY__INFO__TITLE => 'LC__CMDB__CATG__SMVIEW_CABLE__TKA_PARTICIPANT',
                        C__PROPERTY__INFO__DESCRIPTION => 'TKA Participant'
                    ],
                    C__PROPERTY__DATA => [
                        C__PROPERTY__DATA__FIELD => 'isys_catg_smview_cable_route_list__tka_participant'
                    ],
                    C__PROPERTY__UI => [
                        C__PROPERTY__UI__ID => 'C__CATG__SMVIEW_CABLE_ROUTE_TKA_PARTICIPANT',
                        C__PROPERTY__UI__PARAMS => [
                            'p_bReadonly' => 1
                        ]
                    ]
                ]
            ),
            'is_external' => array_replace_recursive(
                isys_cmdb_dao_category_pattern::dialog(),
                [
                    C__PROPERTY__INFO => [
                        C__PROPERTY__INFO__TITLE => 'LC__CMDB__CATG__SMVIEW_CABLE__IS_EXTERNAL',
                        C__PROPERTY__INFO__DESCRIPTION => 'Is External'
                    ],
                    C__PROPERTY__DATA => [
                        C__PROPERTY__DATA__FIELD => 'isys_catg_smview_cable_route_list__is_external',
                        C__PROPERTY__DATA__SELECT => idoit\Module\Report\SqlQuery\Structure\SelectSubSelect::factory(
                            'SELECT (CASE WHEN isys_catg_smview_cable_route_list__is_external = \'1\' THEN ' .
                            $this->convert_sql_text('LC__UNIVERSAL__YES') . ' WHEN isys_catg_smview_cable_route_list__is_external = \'0\' THEN ' .
                            $this->convert_sql_text('LC__UNIVERSAL__NO') . ' END) FROM isys_catg_smview_cable_route_list',
                            'isys_catg_smview_cable_route_list',
                            'isys_catg_smview_cable_route_list__id',
                            'isys_catg_smview_cable_route_list__isys_obj__id'
                        ),
                        C__PROPERTY__DATA__JOIN   => [
                            idoit\Module\Report\SqlQuery\Structure\SelectJoin::factory('isys_catg_smview_cable_route_list', 'LEFT', 'isys_catg_smview_cable_route_list__isys_obj__id', 'isys_obj__id')
                        ]
                    ],
                    C__PROPERTY__UI => [
                        C__PROPERTY__UI__ID => 'C__CATG__SMVIEW_CABLE_IS_EXTERNAL',
                        C__PROPERTY__UI__PARAMS => [
                            'p_arData'   => get_smarty_arr_YES_NO(),
                            'p_strClass' => 'input-small'
                        ]
                    ]
                ]
            ),
            'damping_left1' => array_replace_recursive(
                isys_cmdb_dao_category_pattern::text(),
                [
                    C__PROPERTY__INFO => [
                        C__PROPERTY__INFO__TITLE => 'LC__CMDB__CATG__SMVIEW_CABLE__DAMPING_LEFT1',
                        C__PROPERTY__INFO__DESCRIPTION => 'Damping Left 1'
                    ],
                    C__PROPERTY__DATA => [
                        C__PROPERTY__DATA__FIELD => 'isys_catg_smview_cable_route_list__damping_left1'
                    ],
                    C__PROPERTY__UI => [
                        C__PROPERTY__UI__ID => 'C__CATG__SMVIEW_CABLE_ROUTE_DAMPING_LEFT1'
                    ]
                ]
            ),
            'damping_left2' => array_replace_recursive(
                isys_cmdb_dao_category_pattern::text(),
                [
                    C__PROPERTY__INFO => [
                        C__PROPERTY__INFO__TITLE => 'LC__CMDB__CATG__SMVIEW_CABLE__DAMPING_LEFT2',
                        C__PROPERTY__INFO__DESCRIPTION => 'Damping Left 2'
                    ],
                    C__PROPERTY__DATA => [
                        C__PROPERTY__DATA__FIELD => 'isys_catg_smview_cable_route_list__damping_left2'
                    ],
                    C__PROPERTY__UI => [
                        C__PROPERTY__UI__ID => 'C__CATG__SMVIEW_CABLE_ROUTE_DAMPING_LEFT2'
                    ]
                ]
            ),
            'damping_right1' => array_replace_recursive(
                isys_cmdb_dao_category_pattern::text(),
                [
                    C__PROPERTY__INFO => [
                        C__PROPERTY__INFO__TITLE => 'LC__CMDB__CATG__SMVIEW_CABLE__DAMPING_RIGHT1',
                        C__PROPERTY__INFO__DESCRIPTION => 'Damping Right 1'
                    ],
                    C__PROPERTY__DATA => [
                        C__PROPERTY__DATA__FIELD => 'isys_catg_smview_cable_route_list__damping_right1'
                    ],
                    C__PROPERTY__UI => [
                        C__PROPERTY__UI__ID => 'C__CATG__SMVIEW_CABLE_ROUTE_DAMPING_RIGHT1'
                    ]
                ]
            ),
            'damping_right2' => array_replace_recursive(
                isys_cmdb_dao_category_pattern::text(),
                [
                    C__PROPERTY__INFO => [
                        C__PROPERTY__INFO__TITLE => 'LC__CMDB__CATG__SMVIEW_CABLE__DAMPING_RIGHT2',
                        C__PROPERTY__INFO__DESCRIPTION => 'Damping Right 2'
                    ],
                    C__PROPERTY__DATA => [
                        C__PROPERTY__DATA__FIELD => 'isys_catg_smview_cable_route_list__damping_right2'
                    ],
                    C__PROPERTY__UI => [
                        C__PROPERTY__UI__ID => 'C__CATG__SMVIEW_CABLE_ROUTE_DAMPING_RIGHT2'
                    ]
                ]
            ),
            // only used to transfer data to UI
            'start_object_types' => array_replace_recursive(
                isys_cmdb_dao_category_pattern::dialog(),
                [
                    C__PROPERTY__INFO => [
                        C__PROPERTY__INFO__TITLE => 'LC__CMDB__CATG__SMVIEW_CABLE__START_OBJECT_TYPES',
                        C__PROPERTY__INFO__DESCRIPTION => 'Start Object Types'
                    ],
                    C__PROPERTY__DATA => [
                        C__PROPERTY__DATA__FIELD => 'isys_catg_smview_cable_wire_list__fake_field_name'
                    ],
                    C__PROPERTY__UI => [
                        C__PROPERTY__UI__ID => 'C__CATG__SMVIEW_CABLE_START_OBJECT_TYPES',
                        C__PROPERTY__UI__PARAMS => [
                                'p_arData' => new isys_callback(
                                    [
                                    'isys_cmdb_dao_category_g_smview_cable_section',
                                    'callback_property_start_object_types'
                                    ]
                                )
                            ]
                    ],
                    C__PROPERTY__PROVIDES => [
                        C__PROPERTY__PROVIDES__SEARCH     => false,
                        C__PROPERTY__PROVIDES__LIST       => false,
                        C__PROPERTY__PROVIDES__REPORT     => false,
                        C__PROPERTY__PROVIDES__VALIDATION => false,
                        C__PROPERTY__PROVIDES__VIRTUAL    => true,
                    ]
                ]
            ),
            // only used to transfer data to UI
            'route_elements' => array_replace_recursive(
                isys_cmdb_dao_category_pattern::text(),
                [
                    C__PROPERTY__INFO => [
                        C__PROPERTY__INFO__TITLE => 'LC__CMDB__CATG__SMVIEW_CABLE__ROUTE_ELEMENTS',
                        C__PROPERTY__INFO__DESCRIPTION => '-'
                    ],
                    C__PROPERTY__DATA => [
                        C__PROPERTY__DATA__FIELD => 'isys_catg_smview_cable_wire_list__fake_field_name'
                    ],
                    C__PROPERTY__UI => [
                        C__PROPERTY__UI__ID => 'C__CATG__SMVIEW_CABLE_ELEMENTS'
                    ],
                    C__PROPERTY__PROVIDES => [
                        C__PROPERTY__PROVIDES__SEARCH     => false,
                        C__PROPERTY__PROVIDES__LIST       => false,
                        C__PROPERTY__PROVIDES__REPORT     => false,
                        C__PROPERTY__PROVIDES__VALIDATION => false,
                        C__PROPERTY__PROVIDES__VIRTUAL    => true,
                    ]
                ]
            ),
            // only used to transfer data to UI
            'start_object' => array_replace_recursive(
                isys_cmdb_dao_category_pattern::object_browser(),
                [
                    C__PROPERTY__INFO => [
                        C__PROPERTY__INFO__TITLE => 'LC__CMDB__CATG__SMVIEW_CABLE__START_OBJECT',
                        C__PROPERTY__INFO__DESCRIPTION => 'OBJECTS'
                    ],
                    C__PROPERTY__DATA => [
                        C__PROPERTY__DATA__FIELD => 'isys_catg_smview_cable_wire_list__fake_field_name'
                    ],
                    C__PROPERTY__UI => [
                        C__PROPERTY__UI__ID => 'C__CATG__SMVIEW_CABLE_START_OBJECT',
                        C__PROPERTY__UI__PARAMS => [
                            'p_arData' => new isys_callback(
                                [
                                    'isys_cmdb_dao_category_g_smview_cable_route',
                                    'callback_property_objects'
                                ]
                            ),
                            'multiselection' => false,
                            'catFilter'      => 'C__CATG__SMVIEW_CABLE_PIN',
                            'p_strClass' => 'input-small',
                        ]
                    ],
                    C__PROPERTY__PROVIDES => [
                        C__PROPERTY__PROVIDES__SEARCH     => false,
                        C__PROPERTY__PROVIDES__LIST       => false,
                        C__PROPERTY__PROVIDES__REPORT     => false,
                        C__PROPERTY__PROVIDES__VALIDATION => false,
                        C__PROPERTY__PROVIDES__VIRTUAL    => true,
                    ]
                ]
            ),
            // only used to transfer data to UI
            'end_object' => array_replace_recursive(
                isys_cmdb_dao_category_pattern::object_browser(),
                [
                    C__PROPERTY__INFO => [
                        C__PROPERTY__INFO__TITLE => 'LC__CMDB__CATG__SMVIEW_CABLE__END_OBJECT',
                        C__PROPERTY__INFO__DESCRIPTION => 'OBJECTS'
                    ],
                    C__PROPERTY__DATA => [
                        C__PROPERTY__DATA__FIELD => 'isys_catg_smview_cable_wire_list__fake_field_name'
                    ],
                    C__PROPERTY__UI => [
                        C__PROPERTY__UI__ID => 'C__CATG__SMVIEW_CABLE_END_OBJECT',
                        C__PROPERTY__UI__PARAMS => [
                            'p_arData' => new isys_callback(
                                [
                                    'isys_cmdb_dao_category_g_smview_cable_route',
                                    'callback_property_objects'
                                ]
                            ),
                            'multiselection' => false,
                            'catFilter'      => 'C__CATG__SMVIEW_CABLE_PIN',
                            'p_strClass' => 'input-small',
                        ]
                    ],
                    C__PROPERTY__PROVIDES => [
                        C__PROPERTY__PROVIDES__SEARCH     => false,
                        C__PROPERTY__PROVIDES__LIST       => false,
                        C__PROPERTY__PROVIDES__REPORT     => false,
                        C__PROPERTY__PROVIDES__VALIDATION => false,
                        C__PROPERTY__PROVIDES__VIRTUAL    => true,
                    ]
                ]
            ),
            // only used to transfer data to UI
            'is_rented' => array_replace_recursive(
                isys_cmdb_dao_category_pattern::dialog(),
                [
                    C__PROPERTY__INFO => [
                        C__PROPERTY__INFO__TITLE => 'LC__CMDB__CATG__SMVIEW_CABLE__IS_RENTED',
                        C__PROPERTY__INFO__DESCRIPTION => 'Is Rented'
                    ],
                    C__PROPERTY__DATA => [
                        C__PROPERTY__DATA__FIELD => 'isys_catg_smview_cable_wire_list__fake_field_name'
                    ],
                    C__PROPERTY__UI => [
                        C__PROPERTY__UI__ID => 'C__CATG__SMVIEW_CABLE_IS_RENTED',
                        C__PROPERTY__UI__PARAMS => [
                            'p_arData'   => get_smarty_arr_YES_NO(),
                            'p_strClass' => 'input-small',
                            'p_bReadonly' => 1,
                        ]
                    ],
                    C__PROPERTY__PROVIDES => [
                        C__PROPERTY__PROVIDES__SEARCH     => false,
                        C__PROPERTY__PROVIDES__LIST       => false,
                        C__PROPERTY__PROVIDES__REPORT     => false,
                        C__PROPERTY__PROVIDES__VALIDATION => false,
                        C__PROPERTY__PROVIDES__VIRTUAL    => true,
                    ]
                ]
            ),
            'associated_route' => array_replace_recursive(
                isys_cmdb_dao_category_pattern::object_browser(),
                [
                    C__PROPERTY__INFO => [
                        C__PROPERTY__INFO__TITLE => 'LC__CMDB__CATG__SMVIEW_CABLE__ASSOCIATED_ROUTE',
                        C__PROPERTY__INFO__DESCRIPTION => 'Associated Route'
                    ],
                    C__PROPERTY__DATA => [
                        C__PROPERTY__DATA__FIELD => 'isys_catg_smview_cable_route_list__associated_route',
                        C__PROPERTY__DATA__SOURCE_TABLE => 'isys_obj',
                        C__PROPERTY__DATA__SELECT       => idoit\Module\Report\SqlQuery\Structure\SelectSubSelect::factory(
                            'SELECT o.isys_obj__title
                            FROM isys_catg_smview_cable_route_list AS main
                            JOIN isys_obj AS o ON o.isys_obj__id = main.isys_catg_smview_cable_route_list__associated_route',
                            'isys_catg_smview_cable_route_list',
                            'main.isys_catg_smview_cable_route_list__id',
                            'main.isys_catg_smview_cable_route_list__isys_obj__id',
                            '',
                            '',
                            idoit\Module\Report\SqlQuery\Structure\SelectCondition::factory([]),
                            idoit\Module\Report\SqlQuery\Structure\SelectGroupBy::factory(['main.isys_catg_smview_cable_route_list__isys_obj__id'])
                        )
                    ],
                    C__PROPERTY__UI => [
                        C__PROPERTY__UI__ID => 'C__CATG__SMVIEW_CABLE_ASSOCIATED_ROUTE',
                        C__PROPERTY__UI__PARAMS => [
                            'multiselection' => false,
                            isys_popup_browser_object_ng::C__CAT_FILTER => 'C__CATG__SMVIEW_CABLE_ROUTE',
                            'p_strClass' => 'input-small',
                        ]
                    ],
                    C__PROPERTY__PROVIDES => [
                        C__PROPERTY__PROVIDES__SEARCH     => false,
                        C__PROPERTY__PROVIDES__LIST       => true,
                        C__PROPERTY__PROVIDES__REPORT     => true,
                        C__PROPERTY__PROVIDES__VALIDATION => false,
                        C__PROPERTY__PROVIDES__VIRTUAL    => true,
                    ]
                ]
            ),
            'redundant_routes' => array_replace_recursive(isys_cmdb_dao_category_pattern::multiselect(), [
                C__PROPERTY__INFO     => [
                    C__PROPERTY__INFO__TITLE       => 'LC__CMDB__CATG__SMVIEW_CABLE__REDUNDANT_ROUTES',
                    C__PROPERTY__INFO__DESCRIPTION => 'Redundant Routes'
                ],
                C__PROPERTY__DATA     => [
                    C__PROPERTY__DATA__FIELD        => 'isys_catg_smview_cable_route_list__id',
                    C__PROPERTY__DATA__TABLE_ALIAS  => 'srv_alias',
                    C__PROPERTY__DATA__SOURCE_TABLE => 'isys_catg_smview_cable_route_list',
                    C__PROPERTY__DATA__REFERENCES   => [
                        'isys_smview_cable_route_2_redundant_route',
                        'isys_smview_cable_route__id'
                    ],
                    C__PROPERTY__DATA__SELECT       => idoit\Module\Report\SqlQuery\Structure\SelectSubSelect::factory(
                        'SELECT o.isys_obj__title
                            FROM isys_catg_smview_cable_route_list AS main
                            INNER JOIN isys_smview_cable_route_2_redundant_route AS sec ON sec.isys_smview_cable_route__id = main.isys_catg_smview_cable_route_list__isys_obj__id
                            INNER JOIN isys_obj AS o ON o.isys_obj__id = sec.isys_smview_cable_redundant_route__id',
                        'isys_catg_smview_cable_route_list',
                        'main.isys_catg_smview_cable_route_list__id',
                        'main.isys_catg_smview_cable_route_list__isys_obj__id',
                        '',
                        '',
                        idoit\Module\Report\SqlQuery\Structure\SelectCondition::factory([]),
                        idoit\Module\Report\SqlQuery\Structure\SelectGroupBy::factory(['main.isys_catg_smview_cable_route_list__isys_obj__id'])
                    )
                ],
                C__PROPERTY__UI       => [
                    C__PROPERTY__UI__ID     => 'C__CATG__SMVIEW_CABLE_REDUNDANT_ROUTE',
                    C__PROPERTY__UI__PARAMS => [
                        'p_strTable'   => 'isys_smview_cable_route_view',
                        'placeholder'  => isys_application::instance()->container->get('language')
                            ->get('LC__CMDB__CATG__SMVIEW_CABLE__REDUNDANT_ROUTES'),
                        'p_onComplete' => "idoit.callbackManager.triggerCallback('cmdb-catg-redundant-route-update', selected);",
                        'multiselect'  => true,
                    ]
                ],
                C__PROPERTY__PROVIDES => [
                    C__PROPERTY__PROVIDES__SEARCH  => false,
                    C__PROPERTY__PROVIDES__LIST    => true,
                    C__PROPERTY__PROVIDES__VIRTUAL => true,
                    C__PROPERTY__PROVIDES__REPORT  => false
                ],
                C__PROPERTY__FORMAT   => [
                    C__PROPERTY__FORMAT__CALLBACK => [
                        'isys_export_helper',
                        'dialog'
                    ]
                ]
            ]),
        ];
    }

    /**
     * Get all assigned redundant routes.
     *
     * @param  int $p_obj_id
     * @return isys_component_dao_result
     * @throws Exception
     * @throws isys_exception_database
     */
    public function get_assigned_redundant_routes($p_obj_id)
    {
        $l_sql = 'SELECT obj.isys_obj__id, obj.isys_obj__title, assoc_obj.isys_obj__id AS associated_obj_id, assoc_obj.isys_obj__title AS associated_obj_title
			FROM isys_smview_cable_route_2_redundant_route AS main
			INNER JOIN isys_obj obj ON main.isys_smview_cable_redundant_route__id = obj.isys_obj__id
            LEFT JOIN isys_catg_smview_cable_route_list l ON l.isys_catg_smview_cable_route_list__isys_obj__id = obj.isys_obj__id
            LEFT JOIN isys_catg_smview_cable_route_list l2 ON l2.isys_catg_smview_cable_route_list__isys_obj__id = l.isys_catg_smview_cable_route_list__associated_route
            LEFT JOIN isys_obj assoc_obj ON l2.isys_catg_smview_cable_route_list__isys_obj__id = assoc_obj.isys_obj__id
			WHERE main.isys_smview_cable_route__id = ' . $this->convert_sql_id($p_obj_id) . '
            UNION
            SELECT obj.isys_obj__id, obj.isys_obj__title, assoc_obj.isys_obj__id AS associated_obj_id, assoc_obj.isys_obj__title AS associated_obj_title
			FROM isys_smview_cable_route_2_redundant_route AS main
			INNER JOIN isys_obj obj ON main.isys_smview_cable_route__id = obj.isys_obj__id
			LEFT JOIN isys_catg_smview_cable_route_list l ON l.isys_catg_smview_cable_route_list__isys_obj__id = obj.isys_obj__id
            LEFT JOIN isys_catg_smview_cable_route_list l2 ON l2.isys_catg_smview_cable_route_list__isys_obj__id = l.isys_catg_smview_cable_route_list__associated_route
            LEFT JOIN isys_obj assoc_obj ON l2.isys_catg_smview_cable_route_list__isys_obj__id = assoc_obj.isys_obj__id
			WHERE main.isys_smview_cable_redundant_route__id = ' . $this->convert_sql_id($p_obj_id) . '
			ORDER BY isys_obj__title';
        return $this->retrieve($l_sql . ';');
    }

    /**
     * Callback method for start object types.
     *
     * @return array
     * @throws isys_exception_database
     */
    public function callback_property_objects()
    {
        $query = "SELECT 
                o.isys_obj__id,
                o.isys_obj__title
            FROM isys_catg_smview_cable_pin_list l
            JOIN isys_obj o ON l.isys_catg_smview_cable_pin_list__isys_obj__id = o.isys_obj__id
            GROUP BY o.isys_obj__id;";
        $res = $this->retrieve($query);

        $objects = array();
        while ($row = $res->get_row()) {
            $objects[$row['isys_obj__id']] = $row['isys_obj__title'];
        }
        return $objects;
    }

    /**
     * Callback method for route usages.
     *
     * @return array
     * @throws isys_exception_database
     */
    public function callback_property_route_usages()
    {
        $dao = new isys_cmdb_dao_smview_cable_route_usage($this->m_db);
        $res = $dao->get_objects();
        $usages = [];
        foreach ($res as $usage) {
            $usages[$usage['id']] = $usage['name'];
        }
        return $usages;
    }

    /**
     * Callback method for associated routes.
     *
     * @param  isys_request $request
     * @return array
     * @throws isys_exception_database
     */
    public function callback_property_associated_route($request)
    {
        $obj_id = $request ? $request->get_object_id() : -1;
        $query = "SELECT
                o.isys_obj__id,
                o.isys_obj__title
            FROM isys_catg_smview_cable_route_list l
            JOIN isys_obj o ON l.isys_catg_smview_cable_route_list__isys_obj__id = o.isys_obj__id
            WHERE isys_catg_smview_cable_route_list__associated_route IS NULL OR isys_catg_smview_cable_route_list__associated_route = $obj_id
            GROUP BY o.isys_obj__id;";
        $res = $this->retrieve($query);

        $objects = array();
        while ($row = $res->get_row()) {
            $objects[$row['isys_obj__id']] = $row['isys_obj__title'];
        }
        asort($objects);
        return $objects;
    }

    /**
     * Creates new entity.
     *
     * @param  array $p_data Properties in a associative array with tags as keys and their corresponding values as values.
     * @return mixed  Returns created entity's identifier (int) or false (bool).
     * @throws isys_exception_dao
     * @throws isys_exception_database
     */
    public function create_data($p_data)
    {
        $route_usage_id = isset($p_data['route_usage_id']) && $p_data['route_usage_id'] != '-1' ? $p_data['route_usage_id'] : null;
        $is_external = isset($p_data['is_external']) ? $p_data['is_external'] == '1' : null;
        $associated_route = isset($p_data['associated_route']) && $p_data['associated_route'] != '' ? $p_data['associated_route'] : null;

        $params = array(
            'obj_id'      => $p_data['isys_obj__id'],
            'description' => $p_data['description'],
        );
        $optionalParams = array(
            'connection_count'         => $p_data['connection_count'] ?? null,
            'current_connection_count' => $p_data['current_connection_count'] ?? null,
            'permission'               => $p_data['permission'] ?? null,
            'location'                 => $p_data['location'] ?? null,
            'room'                     => $p_data['room'] ?? null,
            'device_type'              => $p_data['device_type'] ?? null,
            'device_number'            => $p_data['device_number'] ?? null,
            'phone_number'             => $p_data['phone_number'] ?? null,
            'route_usage_id'           => $route_usage_id,
            'phone_subscriber'         => $p_data['phone_subscriber'] ?? null,
            'hint'                     => $p_data['hint'] ?? null,
            'is_external'              => $is_external,
            'associated_route'         => $associated_route,
            'measured_length'          => $p_data['measured_length'] ?? null,
            'measure_date'             => $p_data['measure_date'] ?? null,
            'start_obj_id'             => null,
            'end_obj_id'               => null,
            'tka_participant'          => null,
            'damping_left1'            => $p_data['damping_left1'] ?? null,
            'damping_left2'            => $p_data['damping_left2'] ?? null,
            'damping_right1'           => $p_data['damping_right1'] ?? null,
            'damping_right2'           => $p_data['damping_right2'] ?? null,
        );
        $dao = new \isys_cmdb_dao_smview_cable_route($this->m_db);
        $id = $dao->create_object($params, $optionalParams);

        if (isset($p_data['route_elements'])) {
            // handle route elements only if posted
            $this->_handle_route_elements($id, $p_data, $associated_route);
        }

        $this->update_associated_route($p_data['isys_obj__id'], $associated_route);

        $redundantRoutes = $_POST['C__CATG__SMVIEW_CABLE_REDUNDANT_ROUTE'] ?? [-1];
        $this->update_redundant_routes($p_data['isys_obj__id'], $redundantRoutes);
        return $id;
    }

    /**
     * Updates existing entity.
     *
     * @param  int   $p_list_id Entity's identifier
     * @param  array $p_data    Properties in a associative array with tags as keys and their corresponding values as values.
     * @return boolean
     * @throws isys_exception_dao
     * @throws isys_exception_database
     */
    public function save_data($p_list_id, $p_data)
    {
        $route_usage_id = isset($p_data['route_usage_id']) && $p_data['route_usage_id'] != '-1' ? $p_data['route_usage_id'] : null;
        $is_external = isset($p_data['is_external']) ? $p_data['is_external'] == '1' : null;
        $tka_participant = $this->m_data['isys_catg_smview_cable_route_list__tka_participant'] ?: null;
        $associated_route = isset($p_data['associated_route']) && $p_data['associated_route'] != '' ? $p_data['associated_route'] : null;

        $params = array(
            'description' => $p_data['description'],
        );
        $optionalParams = array(
            'connection_count'         => $p_data['connection_count'] ?? null,
            'current_connection_count' => $p_data['current_connection_count'] ?? null,
            'permission'               => $p_data['permission'] ?? null,
            'location'                 => $p_data['location'] ?? null,
            'room'                     => $p_data['room'] ?? null,
            'device_type'              => $p_data['device_type'] ?? null,
            'device_number'            => $p_data['device_number'] ?? null,
            'phone_number'             => $p_data['phone_number'] ?? null,
            'phone_subscriber'         => $p_data['phone_subscriber'] ?? null,
            'hint'                     => $p_data['hint'] ?? null,
            'measured_length'          => $p_data['measured_length'] ?? null,
            'measure_date'             => $p_data['measure_date'] ?? null,
            'start_obj_id'             => null,
            'end_obj_id'               => null,
            'tka_participant'          => $tka_participant,
            'route_usage_id'           => $route_usage_id,
            'is_external'              => $is_external,
            'associated_route'         => $associated_route,
            'damping_left1'            => $p_data['damping_left1'] ?? null,
            'damping_left2'            => $p_data['damping_left2'] ?? null,
            'damping_right1'           => $p_data['damping_right1'] ?? null,
            'damping_right2'           => $p_data['damping_right2'] ?? null,
        );
        
        $dao = new isys_cmdb_dao_smview_cable_route($this->m_db);
        $success = $dao->update_object($p_list_id, $params, $optionalParams);

        if (isset($p_data['route_elements'])) {
            // handle route elements only if posted
            $this->_handle_route_elements($p_list_id, $p_data, $associated_route);
        }

        $this->update_associated_route($this->m_object_id, $associated_route);

        $redundantRoutes = $_POST['C__CATG__SMVIEW_CABLE_REDUNDANT_ROUTE'] ?? [-1];
        $this->update_redundant_routes($this->m_object_id, $redundantRoutes);
        return $success;
    }

    /**
     * Handle route elements.
     *
     * @param  int      $id
     * @param  array    $p_data
     * @param  int|null $associated_route_id
     * @throws isys_exception_dao
     * @throws isys_exception_database
     */
    private function _handle_route_elements($id, $p_data, $associated_route_id = null)
    {
        if (! isset($p_data['route_elements'])) {
            return;
        }

        $jsonElements = $p_data['route_elements'];
        $this->_persist_route_elements($id, $jsonElements);

        if (empty($associated_route_id)) {
            return;
        }

        // create a list of associated elements
        $associated_elements = [];
        $elements = json_decode($jsonElements, true);
        foreach ($elements as $e) {
            if (! empty($e['associated_element'])) {
                $associated_elements[] = $e['associated_element'];
            }
        }

        // load associate route by object ID
        $associated_route = $this->get_data(null, $associated_route_id)->get_row();
        $this->_persist_route_elements($associated_route['isys_catg_smview_cable_route_list__id'], json_encode($associated_elements));
    }

    /**
     * Persist route elements.
     *
     * @param  int $id
     * @param string $elements
     * @throws isys_exception_dao
     * @throws isys_exception_database
     */
    private function _persist_route_elements($id, $elements)
    {
        // first get current elements (to determine patches to be deleted later on)
        $route_element_dao = new isys_cmdb_dao_category_g_smview_cable_route_element($this->m_db);
        $current_elements = $route_element_dao->get_elements_by_route_id($id, false, false);

        // save new elements
        $this->_save_route_elements($id, $elements);

        // create new patches and remove obsolete ones
        $route_element_dao->patch_route_elements($id, $current_elements);
    }

    /**
     * Save route elements.
     *
     * @param  int    $route_id
     * @param  string $json_elements
     * @throws isys_exception_dao
     * @throws isys_exception_database
     */
    private function _save_route_elements($route_id, $json_elements)
    {
        $route_element_dao = new isys_cmdb_dao_smview_cable_route_element($this->m_db);

        // remove old route elements
        $current_elements = $route_element_dao->filter_objects(array('route_id' => $route_id));
        foreach ($current_elements as $current_element) {
            $route_element_dao->delete_object($current_element['id']);
        }

        if (empty($json_elements)) {
            return;
        }
        
        $elements = json_decode($json_elements);
        $start_obj_id = null;
        $end_obj_id = null;
        foreach ($elements as $element) {
            if (empty($element->wire_id) && empty($element->section_id)) {
                continue;
            }
            
            if (! $start_obj_id) {
                $start_obj_id = $element->obj_out_id;
            }
            $end_obj_id = $element->obj_in_id;

            $params = array(
                'route_id'    => $route_id,
                'index'       => $element->index,
            );
            $optional_params = array(
                'wire_id'    => $element->wire_id,
                'section_id' => $element->section_id,
            );
            $route_element_dao->create_object($params, $optional_params);
        }

        $this->_update_route_start_and_end_objects($route_id, $start_obj_id, $end_obj_id);
    }

    /**
     * Update routes start- and end-object.
     *
     * @param  int $route_id
     * @param  int $start_obj_id
     * @param  int $end_obj_id
     * @throws isys_exception_dao
     * @throws isys_exception_database
     */
    private function _update_route_start_and_end_objects($route_id, $start_obj_id, $end_obj_id)
    {
        $dao = new isys_cmdb_dao_smview_cable_route($this->m_db);
        $dao->get_object('id', $route_id);
        $params = array(
            'start_obj_id' => $start_obj_id,
            'end_obj_id'   => $end_obj_id,
        );
        $dao->update_object($route_id, $params);
    }

    /**
     * Updated associated route.
     *
     * @param  int $obj_id
     * @param  int $associated_obj_id
     * @throws isys_exception_dao
     * @throws isys_exception_database
     */
    public function update_associated_route($obj_id, $associated_obj_id)
    {
        $associated_obj_id = $associated_obj_id != -1 ? $associated_obj_id : null;
        $sql = "SELECT
                    isys_catg_smview_cable_route_list__id,
                    isys_catg_smview_cable_route_list__isys_obj__id
                FROM isys_catg_smview_cable_route_list
                WHERE isys_catg_smview_cable_route_list__associated_route = $obj_id;";
        $res = $this->retrieve($sql);
        while ($row = $res->get_row()) {
            if ($row['isys_catg_smview_cable_route_list__isys_obj__id'] != $associated_obj_id) {
                $sql = "UPDATE isys_catg_smview_cable_route_list SET isys_catg_smview_cable_route_list__associated_route = NULL
                        WHERE isys_catg_smview_cable_route_list__id = " . $row['isys_catg_smview_cable_route_list__id'];
                $this->update($sql) && $this->apply_update();
            }
            $sql = "UPDATE isys_catg_smview_cable_route_list SET isys_catg_smview_cable_route_list__associated_route = NULL
                    WHERE isys_catg_smview_cable_route_list__isys_obj__id = $obj_id;";
            $this->update($sql) && $this->apply_update();
        }

        if ($associated_obj_id) {
            $this->_add_or_update_category($obj_id, $associated_obj_id);
            $this->_add_or_update_category($associated_obj_id, $obj_id);
        }
    }

    /**
     * Add or update this category.
     *
     * @param  int $obj_id
     * @param  int $associated_obj_id
     * @throws isys_exception_dao
     */
    private function _add_or_update_category($obj_id, $associated_obj_id)
    {
        $catg = $this->get_data(null, $obj_id)->get_row();
        if ($catg) {
            $sql = "UPDATE isys_catg_smview_cable_route_list SET isys_catg_smview_cable_route_list__associated_route = $associated_obj_id
                    WHERE isys_catg_smview_cable_route_list__isys_obj__id = $obj_id";

        } else {
            $sql = "INSERT INTO isys_catg_smview_cable_route_list SET
                        isys_catg_smview_cable_route_list__associated_route = $associated_obj_id,
                        isys_catg_smview_cable_route_list__isys_obj__id = $obj_id,
                        isys_catg_smview_cable_route_list__status = 2";
        }
        $this->update($sql) && $this->apply_update();
    }

    /**
     * Update redundant routes.
     *
     * @param  int $obj_id
     * @param  array $redundant_routes
     * @throws isys_exception_dao
     * @throws isys_exception_database
     */
    public function update_redundant_routes($obj_id, $redundant_routes)
    {
        if (is_array($redundant_routes) && count($redundant_routes)) {
            if (count($redundant_routes) == 1 && $redundant_routes[0] == -1) {
                // flag to reset all assignments
                $redundant_routes = [];
            }

            // clear current assignments
            $all_routes = $redundant_routes;
            $all_routes[] = $obj_id;
            foreach ($all_routes as $routeObjId) {
                $current_routes = $this->get_assigned_redundant_routes($routeObjId);
                while ($row = $current_routes->get_row()) {
                    // remove assignment of each redundant route
                    $route_obj_id = $row['isys_obj__id'];
                    $l_sql = 'DELETE FROM isys_smview_cable_route_2_redundant_route
                              WHERE isys_smview_cable_route__id = ' . $this->convert_sql_id($route_obj_id) . '
                              OR isys_smview_cable_redundant_route__id = ' . $this->convert_sql_id($route_obj_id);
                    $this->update($l_sql) && $this->apply_update();
                }
            }

            if (! empty($redundant_routes)) {
                $l_values = '';
                $current_route_id = $obj_id;
                while (count($redundant_routes) > 0) {
                    // every route is redundant to the other ones
                    foreach ($redundant_routes as $route_id) {
                        if (! empty($route_id)) {
                            $l_values .= ' (' . $this->convert_sql_id($current_route_id) . ', ' . $this->convert_sql_id($route_id) . '),';
                        }
                    }
                    $current_route_id = array_shift($redundant_routes);
                }

                if (! empty($l_values)) {
                    $l_insert = 'INSERT INTO isys_smview_cable_route_2_redundant_route (isys_smview_cable_route__id, isys_smview_cable_redundant_route__id)
                                 VALUES ' . rtrim($l_values, ',');
                    $this->update($l_insert);
                }
            }
        }
    }
}
