<?php

/**
 * i-doit
 *
 * Administration Unit DAO for SM-VIEW Cable.
 *
 * @package    i-doit
 * @subpackage smview_cable
 * @author     Steve Groeber <steve.groeber@shd-online.de>
 * @copyright  SHD System-Haus-Dresden GmbH
 * @license    http://www.i-doit.com/license
 */
class isys_cmdb_dao_smview_cable_admin_unit extends isys_cmdb_dao_smview_cable_abstract
{
    
    /**
     * Mapping of database and API keys
     *
     * @var array
     */
    protected $db_to_api_map = array(
        'isys_catg_smview_cable_admin_unit__id'             => 'id',
        'isys_catg_smview_cable_admin_unit__parent_id'      => 'parent_id',
        'isys_catg_smview_cable_admin_unit__classification' => 'classification',
        'isys_catg_smview_cable_admin_unit__description'    => 'description',
    );
    
    /**
     * Name of the table.
     *
     * @var string
     */
    protected $table_name = 'isys_catg_smview_cable_admin_unit';
    
    /**
     * Name of the primary key field.
     *
     * @var string
     */
    protected $primary_key_field = 'isys_catg_smview_cable_admin_unit__id';
    
    /**
     * Get data method.
     *
     * @param  int $obj_id
     * @return array
     */
    public function get_raw_admin_units()
    {
        $query = "SELECT isys_catg_smview_cable_admin_unit__id as id,
                isys_catg_smview_cable_admin_unit__description as description,
                isys_catg_smview_cable_admin_unit__classification as classification
                FROM isys_catg_smview_cable_admin_unit;";
        return $this->retrieve($query);
    }
}
