<?php

/**
 * i-doit
 *
 * Capacity View DAO for SM-VIEW Cable.
 *
 * @package    i-doit
 * @subpackage smview_cable
 * @author     Steve Groeber <steve.groeber@shd-online.de>
 * @copyright  SHD System-Haus-Dresden GmbH
 * @license    http://www.i-doit.com/license
 */
class isys_cmdb_dao_smview_cable_capacity_view extends isys_cmdb_dao_smview_cable_abstract_view
{

    /**
     * Select field mapping.
     *
     * Used to create select-fields like "$key AS $value,".
     *
     * @var array
     */
    protected $select_field_mapping = array(
        'c.id'               => 'id',
        'c.obj_id'           => 'obj_id',
        'c.state_id'         => 'state_id',
        'c.user_state'       => 'user_state',
        'c.group_id'         => 'group_id',
        'c.length'           => 'length',
        'c.capacity'         => 'capacity',
        'c.net_type'         => 'net_type',
        'c.admin_unit_id'    => 'admin_unit_id',
        'c.type_id'          => 'type_id',
        'c.is_section_cable' => 'is_section_cable',
        'c.location_in_id'   => 'location_in_id',
        'c.location_out_id'  => 'location_out_id',
        'c.wire_count'       => 'wire_count',
        'c.patched_wires'    => 'patched_wires',
    );

    /**
     * Get base query.
     *
     * @return string
     */
    protected function _get_base_query()
    {
        $query = "SELECT ";
        foreach ($this->select_field_mapping as $db => $name) {
            $query .= " $db AS $name,";
        }
        $base_query = trim($query, ',');
        $base_query .= " FROM isys_catg_smview_cable_capacity_view c
            WHERE 1=1 ";
        return $base_query;
    }
}
