<?php

/**
 * i-doit
 *
 * Connected Pin View DAO for SM-VIEW Cable.
 *
 * @package    i-doit
 * @subpackage smview_cable
 * @author     Steve Groeber <steve.groeber@shd-online.de>
 * @copyright  SHD System-Haus-Dresden GmbH
 * @license    http://www.i-doit.com/license
 */
class isys_cmdb_dao_smview_cable_connected_pin_view extends isys_cmdb_dao_smview_cable_abstract_view
{
    
    /**
     * Select field mapping.
     *
     * Used to create select-fields like "$key AS $value,".
     *
     * @var array
     */
    protected $select_field_mapping = array(
        'wp.isys_catg_smview_cable_wire_pin__connected_pin_id' => 'pin_id',
        'wp.isys_catg_smview_cable_wire_pin__id'               => 'wire_pin_id',
        'wp.isys_catg_smview_cable_wire_pin__wire_id'          => 'wire_id',
        'wl.isys_catg_smview_cable_wire_list__isys_obj__id'    => 'cable_id',
        'p.isys_catg_smview_cable_pin_list__description'       => 'pin_title',
        'p.isys_catg_smview_cable_pin_list__classification'    => 'pin_scope',
        'p.isys_catg_smview_cable_pin_list__sibling_id'        => 'sibling_id',
        'i.isys_catg_smview_cable_pin_list__patch_id'          => 'patch_pin_id',
        'p.isys_catg_smview_cable_pin_list__isys_obj__id'      => 'obj_id',
        'o.isys_obj__title'                                    => 'obj_title',
    );
    
    /**
     * Get base query.
     *
     * @return string
     */
    protected function _get_base_query()
    {
        $query = "SELECT ";
        foreach ($this->select_field_mapping as $db => $name) {
            $query .= " $db AS $name,";
        }
        $base_query = trim($query, ',');
        $base_query .= " FROM isys_catg_smview_cable_wire_pin wp
            JOIN isys_catg_smview_cable_wire_list wl ON wp.isys_catg_smview_cable_wire_pin__wire_id = wl.isys_catg_smview_cable_wire_list__id
            JOIN isys_catg_smview_cable_pin_list p ON wp.isys_catg_smview_cable_wire_pin__connected_pin_id = p.isys_catg_smview_cable_pin_list__id
            JOIN isys_obj o ON p.isys_catg_smview_cable_pin_list__isys_obj__id = o.isys_obj__id
            LEFT JOIN isys_catg_smview_cable_pin_list i ON p.isys_catg_smview_cable_pin_list__sibling_id = i.isys_catg_smview_cable_pin_list__id
            WHERE 1=1 ";
        return $base_query;
    }
}
