<?php

/**
 * i-doit
 *
 * ETSI Bay Item DAO for SM-VIEW Cable.
 *
 * @package    i-doit
 * @subpackage smview_cable
 * @author     Steve Groeber <steve.groeber@shd-online.de>
 * @copyright  SHD System-Haus-Dresden GmbH
 * @license    http://www.i-doit.com/license
 */
class isys_cmdb_dao_smview_cable_etsi_bay_item extends isys_cmdb_dao_smview_cable_abstract
{

    /**
     * Mapping of database and API keys
     *
     * @var array
     */
    protected $db_to_api_map = array(
        'isys_catg_smview_cable_etsi_bay_item__id'                 => 'id',
        'isys_catg_smview_cable_etsi_bay_item__bay_id'             => 'bay_id',
        'isys_catg_smview_cable_etsi_bay_item__color_id'           => 'color_id',
        'isys_catg_smview_cable_etsi_bay_item__title'              => 'title',
        'isys_catg_smview_cable_etsi_bay_item__short_name'         => 'short_name',
        'isys_catg_smview_cable_etsi_bay_item__position'           => 'position',
        'isys_catg_smview_cable_etsi_bay_item__he'                 => 'he',
        'isys_catg_smview_cable_etsi_bay_item__project_identifier' => 'project_identifier',
        'isys_catg_smview_cable_etsi_bay_item__comment'            => 'comment',
        'isys_catg_smview_cable_etsi_bay_item__status'             => 'status',
    );

    /**
     * Name of the table.
     *
     * @var string
     */
    protected $table_name = 'isys_catg_smview_cable_etsi_bay_item';

    /**
     * Name of the primary key field.
     *
     * @var string
     */
    protected $primary_key_field = 'isys_catg_smview_cable_etsi_bay_item__id';
}
