<?php

/**
 * i-doit
 *
 * ETSI Bay Item Export DAO for SM-VIEW Cable.
 *
 * @package    i-doit
 * @subpackage smview_cable
 * @author     Steve Groeber <steve.groeber@shd-online.de>
 * @copyright  SHD System-Haus-Dresden GmbH
 * @license    http://www.i-doit.com/license
 */
class isys_cmdb_dao_smview_cable_etsi_bay_item_export extends isys_cmdb_dao_smview_cable_abstract
{

    /**
     * Mapping of database and API keys
     *
     * @var array
     */
    protected $db_to_api_map = array(
        'isys_catg_smview_cable_etsi_bay_export_item__id'          => 'id',
        'isys_catg_smview_cable_etsi_bay_export_item__list_id'     => 'list_id',
        'isys_catg_smview_cable_etsi_bay_export_item__bay_item_id' => 'bay_item_id',
        'isys_catg_smview_cable_etsi_bay_export_item__position'    => 'position',
    );

    /**
     * Name of the table.
     *
     * @var string
     */
    protected $table_name = 'isys_catg_smview_cable_etsi_bay_export_item';

    /**
     * Name of the primary key field.
     *
     * @var string
     */
    protected $primary_key_field = 'isys_catg_smview_cable_etsi_bay_export_item__id';
}
