<?php

/**
 * i-doit
 *
 * ETSI Device Color Wire Status DAO for SM-VIEW Cable.
 *
 * @package    i-doit
 * @subpackage smview_cable
 * @author     Steve Groeber <steve.groeber@shd-online.de>
 * @copyright  2021 SHD System-Haus-Dresden GmbH
 * @license    http://www.i-doit.com/license
 */
class isys_cmdb_dao_smview_cable_etsi_device_color_wire_status extends isys_cmdb_dao_smview_cable_abstract
{

    /**
     * Mapping of database and API keys
     *
     * @var array
     */
    protected $db_to_api_map = array(
        'isys_catg_smview_cable_etsi_device_color_wire_status__id'        => 'id',
        'isys_catg_smview_cable_etsi_device_color_wire_status__device_id' => 'device_id',
        'isys_catg_smview_cable_etsi_device_color_wire_status__status_id' => 'status_id',
        'isys_catg_smview_cable_etsi_device_color_wire_status__operator'  => 'operator',
        'isys_catg_smview_cable_etsi_device_color_wire_status__not'       => 'not',
    );

    /**
     * Name of the table.
     *
     * @var string
     */
    protected $table_name = 'isys_catg_smview_cable_etsi_device_color_wire_status';

    /**
     * Name of the primary key field.
     *
     * @var string
     */
    protected $primary_key_field = 'isys_catg_smview_cable_etsi_device_color_wire_status__id';
}
