<?php

/**
 * i-doit
 *
 * ETSI Export Object DAO for SM-VIEW Cable.
 *
 * @package    i-doit
 * @subpackage smview_cable
 * @author     Steve Groeber <steve.groeber@shd-online.de>
 * @copyright  2020 SHD System-Haus-Dresden GmbH
 * @license    http://www.i-doit.com/license
 */
class isys_cmdb_dao_smview_cable_etsi_export_object extends isys_cmdb_dao_smview_cable_abstract
{

    /**
     * Mapping of database and API keys
     *
     * @var array
     */
    protected $db_to_api_map = array(
        'isys_catg_smview_cable_etsi_export_object__id'                 => 'id',
        'isys_catg_smview_cable_etsi_export_object__export_id'          => 'export_id',
        'isys_catg_smview_cable_etsi_export_object__bay_export_list_id' => 'bay_export_list_id',
        'isys_catg_smview_cable_etsi_export_object__position'           => 'position',
    );

    /**
     * Name of the table.
     *
     * @var string
     */
    protected $table_name = 'isys_catg_smview_cable_etsi_export_object';

    /**
     * Name of the primary key field.
     *
     * @var string
     */
    protected $primary_key_field = 'isys_catg_smview_cable_etsi_export_object__id';
}
