<?php

/**
 * i-doit
 *
 * Group DAO for SM-VIEW Cable.
 *
 * @package    i-doit
 * @subpackage smview_cable
 * @author     Steve Groeber <steve.groeber@shd-online.de>
 * @copyright  SHD System-Haus-Dresden GmbH
 * @license    http://www.i-doit.com/license
 */
class isys_cmdb_dao_smview_cable_group extends isys_cmdb_dao_smview_cable_abstract
{
    
    /**
     * Mapping of database and API keys
     *
     * @var array
     */
    protected $db_to_api_map = array(
        'isys_catg_smview_cable_group__id'          => 'id',
        'isys_catg_smview_cable_group__class'       => 'classification',
        'isys_catg_smview_cable_group__description' => 'description',
    );
    
    /**
     * Name of the table.
     *
     * @var string
     */
    protected $table_name = 'isys_catg_smview_cable_group';
    
    /**
     * Name of the primary key field.
     *
     * @var string
     */
    protected $primary_key_field = 'isys_catg_smview_cable_group__id';
    
    /**
     * Get data method.
     *
     * @return array
     */
    public function get_raw_groups()
    {
        $query = "SELECT isys_catg_smview_cable_group__id as id,
                isys_catg_smview_cable_group__description as description,
                isys_catg_smview_cable_group__class as classification
                FROM isys_catg_smview_cable_group;";
        return $this->retrieve($query);
    }
}
