<?php

/**
 * i-doit
 *
 * Configuration DAO for SM-VIEW Cable OrientDB.
 *
 * @package    i-doit
 * @subpackage smview_cable
 * @author     Steve Groeber <steve.groeber@shd-online.de>
 * @copyright  SHD System-Haus-Dresden GmbH
 * @license    http://www.i-doit.com/license
 */
class isys_cmdb_dao_smview_cable_orientdb extends isys_cmdb_dao_smview_cable_abstract
{
    /**
     * Mapping of database and API keys
     *
     * @var array
     */
    protected $db_to_api_map = array(
        'isys_smview_cable_orientdb__id'       => 'id',
        'isys_smview_cable_orientdb__address'  => 'address',
        'isys_smview_cable_orientdb__port'     => 'port',
        'isys_smview_cable_orientdb__database' => 'database',
        'isys_smview_cable_orientdb__username' => 'username',
        'isys_smview_cable_orientdb__password' => 'password',
    );

    /**
     * Name of the table.
     *
     * @var string
     */
    protected $table_name = 'isys_smview_cable_orientdb';

    /**
     * Name of the primary key field.
     *
     * @var string
     */
    protected $primary_key_field = 'isys_smview_cable_orientdb__id';

    /**
     * Update an existing object.
     *
     * @param  int $id
     * @param  array $params
     * @param  array $optionalParams
     * @return boolean
     * @throws isys_exception_dao
     */
    public function update_object($id, $params, $optionalParams = [])
    {
        if (isset($params['password'])) {
            // remove password, if not updated (contains some ****)
            if (substr_count($params['password'], '*') > 1) {
                unset($params['password']);
            }
        }
        return parent::update_object($id, $params, $optionalParams);
    }
}
