<?php

/**
 * i-doit
 *
 * Technology DAO for SM-VIEW Cable.
 *
 * @package    i-doit
 * @subpackage smview_cable
 * @author     Steve Groeber <steve.groeber@shd-online.de>
 * @copyright  SHD System-Haus-Dresden GmbH
 * @license    http://www.i-doit.com/license
 */
class isys_cmdb_dao_smview_cable_technology extends isys_cmdb_dao_smview_cable_abstract
{
    
    /**
     * Mapping of database and API keys
     *
     * @var array
     */
    protected $db_to_api_map = array(
        'isys_catg_smview_cable_technology__id'          => 'id',
        'isys_catg_smview_cable_technology__description' => 'description',
        'isys_catg_smview_cable_technology__technology'  => 'technology',
    );
    
    /**
     * Name of the table.
     *
     * @var string
     */
    protected $table_name = 'isys_catg_smview_cable_technology';
    
    /**
     * Name of the primary key field.
     *
     * @var string
     */
    protected $primary_key_field = 'isys_catg_smview_cable_technology__id';
    
    /**
     * Get data method.
     *
     * @param  int $obj_id
     * @return array
     */
    public function get_raw_types()
    {
        $query = "SELECT isys_catg_smview_cable_technology__id as id,
                isys_catg_smview_cable_technology__description as description,
                isys_catg_smview_cable_technology__technology as technology
                FROM isys_catg_smview_cable_technology;";
        return $this->retrieve($query);
    }
}
