<?php

/**
 * i-doit
 *
 * Type DAO for SM-VIEW Cable.
 *
 * @package    i-doit
 * @subpackage smview_cable
 * @author     Steve Groeber <steve.groeber@shd-online.de>
 * @copyright  SHD System-Haus-Dresden GmbH
 * @license    http://www.i-doit.com/license
 */
class isys_cmdb_dao_smview_cable_type extends isys_cmdb_dao_smview_cable_abstract
{
    
    /**
     * Mapping of database and API keys
     *
     * @var array
     */
    protected $db_to_api_map = array(
        'isys_catg_smview_cable_type__id'            => 'id',
        'isys_catg_smview_cable_type__description'   => 'description',
        'isys_catg_smview_cable_type__wire_count'    => 'wire_count',
        'isys_catg_smview_cable_type__technology_id' => 'technology_id',
    );
    
    /**
     * Name of the table.
     *
     * @var string
     */
    protected $table_name = 'isys_catg_smview_cable_type';
    
    /**
     * Name of the primary key field.
     *
     * @var string
     */
    protected $primary_key_field = 'isys_catg_smview_cable_type__id';

    /**
     * Optional method to add additional informations to an object.
     *
     * @param  array $obj
     * @return array|null
     */
    protected function _get_additional_informations($obj)
    {
        $dao = isys_cmdb_dao_smview_cable_technology::instance(isys_application::instance()->database);
        $tech = $dao->get_object('id', $obj['technology_id']);
        return array(
            'technology' => $tech['description'],
        );
    }
}
