<?php

/**
 * i-doit
 *
 * User Status DAO for SM-VIEW Cable.
 *
 * @package    i-doit
 * @subpackage smview_cable
 * @author     Steve Groeber <steve.groeber@shd-online.de>
 * @copyright  SHD System-Haus-Dresden GmbH
 * @license    http://www.i-doit.com/license
 */
class isys_cmdb_dao_smview_cable_user_state extends isys_cmdb_dao_smview_cable_abstract
{
    
    /**
     * Mapping of database and API keys
     *
     * @var array
     */
    protected $db_to_api_map = array(
        'isys_catg_smview_cable_user_state__id'          => 'id',
        'isys_catg_smview_cable_user_state__name'        => 'name',
        'isys_catg_smview_cable_user_state__description' => 'description',
    );
    
    /**
     * Name of the table.
     *
     * @var string
     */
    protected $table_name = 'isys_catg_smview_cable_user_state';
    
    /**
     * Name of the primary key field.
     *
     * @var string
     */
    protected $primary_key_field = 'isys_catg_smview_cable_user_state__id';

    /**
     * Get data method.
     *
     * @return isys_component_dao_result
     * @throws isys_exception_database
     */
    public function get_raw_user_state()
    {
        $query = "SELECT isys_catg_smview_cable_user_state__id as id,
                isys_catg_smview_cable_user_state__name as name,
                isys_catg_smview_cable_user_state__description as description
                FROM isys_catg_smview_cable_user_state;";
        return $this->retrieve($query);
    }
}
