<?php

/**
 * i-doit
 * DAO: list for SM-VIEW Cable assigned routes.
 *
 * @package    i-doit
 * @subpackage smview_cable
 * @author     Steve Groeber <steve.groeber@shd-online.de>
 * @copyright  2021 SHD System-Haus-Dresden GmbH
 * @license    http://www.i-doit.com/license MIT
 */
class isys_cmdb_dao_list_catg_smview_cable_assigned_routes extends isys_cmdb_dao_list
{

    /**
     * Return constant of category.
     *
     * @return integer
     */
    public function get_category()
    {
        return defined_or_default('C__CATG__SMVIEW_CABLE_ASSIGNED_ROUTES');
    }

    /**
     * Return constant of category type.
     *
     * @return integer
     */
    public function get_category_type()
    {
        return C__CMDB__CATEGORY__TYPE_GLOBAL;
    }

    /**
     * Returns array with table headers.
     *
     * @return array
     */
    public function get_fields()
    {
        return [
            'isys_obj__title' => 'LC__SHD__ROUTE',
        ];
    }

    /**
     * Make a custom row link.
     *
     * @return string
     */
    public function make_row_link()
    {
        return isys_helper_link::get_base() . isys_helper_link::create_url(
            [
                C__CMDB__GET__OBJECT => "[{isys_obj__id}]",
                C__CMDB__GET__CATG   => defined_or_default('C__CATG__SMVIEW_CABLE_ROUTE'),
            ]
        );
    }
}
