<?php

/**
 * i-doit
 *
 * DAO: List of SM-VIEW Cable Assigned Stations.
 *
 * @package    i-doit
 * @subpackage smview_cable
 * @author     Steve Groeber <steve.groeber@shd-online.de>
 * @copyright  2023 SHD System-Haus-Dresden GmbH
 * @license    http://www.i-doit.com/license MIT
 */
class isys_cmdb_dao_list_catg_smview_cable_assigned_stations extends isys_cmdb_dao_list
{

    /**
     * Return constant of category.
     *
     * @return integer
     */
    public function get_category()
    {
        return defined_or_default('C__CATG__SMVIEW_CABLE_ASSIGNED_STATIONS');
    }

    /**
     * Return constant of category type.
     *
     * @return integer
     */
    public function get_category_type()
    {
        return C__CMDB__CATEGORY__TYPE_GLOBAL;
    }

    /**
     * Returns array with table headers.
     *
     * @return array
     */
    public function get_fields()
    {
        return [
            'station_title'                                              => 'LC__SHD__STATION',
            'isys_catg_smview_cable_assigned_stations_list__description' => 'LC__UNIVERSAL__DESCRIPTION',
        ];
    }

    /**
     * Modify row method will be called for each row to alter its content.
     *
     * @param  array &$p_row
     * @throws Exception
     */
    public function modify_row(&$p_row)
    {
        $dao = new isys_cmdb_dao_category_g_global(isys_application::instance()->database);
        $row = $dao->get_data(null, $p_row['isys_catg_smview_cable_assigned_stations_list__station_id'])->get_row();
        $p_row["station_title"] = $row && $row['isys_obj__title'] ? $row['isys_obj__title'] : '';
    }
}
