<?php

/**
 * i-doit
 * DAO: list for SM-VIEW Cable Wires
 *
 * @package    i-doit
 * @subpackage smview_cable
 * @author     Steve Groeber <steve.groeber@shd-online.de>
 * @copyright  SHD System-Haus-Dresden GmbH
 * @license    http://www.i-doit.com/license
 */
class isys_cmdb_dao_list_catg_smview_cable_wire extends isys_cmdb_dao_list
{

    /**
     * Return constant of category.
     *
     * @return integer
     */
    public function get_category()
    {
        return defined_or_default('C__CATG__SMVIEW_CABLE_WIRE');
    }

    /**
     * Return constant of category type.
     *
     * @return integer
     */
    public function get_category_type()
    {
        return C__CMDB__CATEGORY__TYPE_GLOBAL;
    }

    /**
     * Returns array with table headers.
     *
     * @return array
     */
    public function get_fields()
    {
        return [
            "description"          => "LC__CMDB__CATG__SMVIEW_CABLE__DESCRIPTION",
            "color"                => "LC__CMDB__CATG__SMVIEW_CABLE__COLOR",
            "scope"                => "LC__CMDB__CATG__SMVIEW_CABLE__WIRE_SCOPE",
            "user_state"           => "LC__CMDB__CATG__SMVIEW_CABLE__STATE",
            "user_state_name"      => "LC__CMDB__CATG__SMVIEW_CABLE__USER_STATE",
            "connection_type"      => "LC__CMDB__CATG__SMVIEW_CABLE__CONNECTION_TYPE",
            "in_use"               => "LC__CMDB__CATG__SMVIEW_CABLE__WIRE_IN_USE",
            "section_id"           => "LC__SHD__SECTION",
            "route_id"             => "LC__SHD__ROUTE",
            "state_in"             => "LC__CMDB__CATG__SMVIEW_CABLE__WIRE_STATE_IN",
            "description_incoming" => "LC__CMDB__CATG__SMVIEW_CABLE__DESCRIPTION_INCOMING",
            'pin_in_object'        => "LC__CMDB__CATG__SMVIEW_CABLE__PIN_IN_OBJECT",
            'pin_in_purpose'       => "LC__CMDB__CATG__SMVIEW_CABLE__PIN_IN_PURPOSE",
            'pin_in_scope'         => "LC__CMDB__CATG__SMVIEW_CABLE__PIN_IN_SCOPE",
            'pin_in_description'   => "LC__CMDB__CATG__SMVIEW_CABLE__PIN_IN_DESCRIPTION",
            "state_out"            => "LC__CMDB__CATG__SMVIEW_CABLE__WIRE_STATE_OUT",
            "description_outgoing" => "LC__CMDB__CATG__SMVIEW_CABLE__DESCRIPTION_OUTGOING",
            'pin_out_object'       => "LC__CMDB__CATG__SMVIEW_CABLE__PIN_OUT_OBJECT",
            'pin_out_purpose'      => "LC__CMDB__CATG__SMVIEW_CABLE__PIN_OUT_PURPOSE",
            'pin_out_scope'        => "LC__CMDB__CATG__SMVIEW_CABLE__PIN_OUT_SCOPE",
            'pin_out_description'  => "LC__CMDB__CATG__SMVIEW_CABLE__PIN_OUT_DESCRIPTION",
            'extended_location'    => "LC__CMDB__CATG__SMVIEW_CABLE__EXTENDED_LOCATION",
        ];
    }

    /**
     * Modify row method will be called for each row to alter its content.
     *
     * @param  array &$p_row
     * @throws Exception
     */
    public function modify_row(&$p_row)
    {
        $wire_id = $p_row['isys_catg_smview_cable_wire_list__id'];
        $wire_dao = new isys_cmdb_dao_category_g_smview_cable_wire($this->m_db);
        $additional_data = $wire_dao->get_additional_wire_information_by_id($wire_id, true);
        $p_row = array_merge($p_row, $additional_data);
    }
}
