<?php

/**
 * i-doit
 *
 * UI: global category for SM-VIEW Cable.
 *
 * @package    i-doit
 * @subpackage smview_cable
 * @author     Steve Groeber <steve.groeber@shd-online.de>
 * @copyright  SHD System-Haus-Dresden GmbH
 * @license    http://www.i-doit.com/license
 */
class isys_cmdb_ui_category_g_smview_cable extends isys_cmdb_ui_category_global
{

    /**
     * Overwriting this method to set the correct template.
     *
     * @param isys_cmdb_dao_category $p_cat
     */
    public function init(isys_cmdb_dao_category $p_cat)
    {
        parent::init($p_cat);

        $this->set_template(isys_module_smview_cable::get_tpl_dir() . 'module/cmdb/catg__smview_cable.tpl');
    }

    /**
     * Processes the UI for this category
     *
     * @param isys_cmdb_dao_category $p_cat The corresponding category DAO
     */
    public function process(isys_cmdb_dao_category $p_cat)
    {
        parent::process($p_cat);
        $this->disable_ajax_save();
        $this->deactivate_commentary($p_cat);
        
        $this->get_template_component()
            ->assign('assets_dir', isys_module_smview_cable::get_assets_www_dir());
    }
    
    /**
     * Fetches category's title from database.
     *
     * @param  isys_cmdb_dao_category &$p_cat Category's DAO
     * @return string                         Category's title, otherwise error message.
     */
    public function gui_get_title(isys_cmdb_dao_category &$p_cat)
    {
        $language = isys_application::instance()->container->get('language');
        return $language->get('LC__CMDB__CATG__SMVIEW_CABLE__TITLE');
    }
}
