<?php

/**
 * i-doit
 *
 * UI: global category for SM-VIEW Cable assigned routes.
 *
 * @package    i-doit
 * @subpackage smview_cable
 * @author     Steve Groeber <steve.groeber@shd-online.de>
 * @copyright  2021 SHD System-Haus-Dresden GmbH
 * @license    http://www.i-doit.com/license
 */
class isys_cmdb_ui_category_g_smview_cable_assigned_routes extends isys_cmdb_ui_category_global
{

    /**
     * Processes the UI for this category
     *
     * @param  isys_cmdb_dao_category $p_cat The corresponding category DAO
     * @return null
     * @throws isys_exception_cmdb
     * @throws isys_exception_general
     */
    public function process(isys_cmdb_dao_category $p_cat)
    {
        return $this->process_list($p_cat);
    }

    /**
     * Fetches category's title from database.
     *
     * @param  isys_cmdb_dao_category &$p_cat Category's DAO
     * @return string                         Category's title, otherwise error message.
     * @throws Exception
     */
    public function gui_get_title(isys_cmdb_dao_category &$p_cat)
    {
        $language = isys_application::instance()->container->get('language');
        return $language->get('LC__CMDB__CATG__SMVIEW_CABLE__ASSIGNED_ROUTES_TITLE');
    }
}
