<?php

/**
 * i-doit
 *
 * UI: global category for SM-VIEW Cable Virtual Route Element.
 *
 * @package    i-doit
 * @subpackage smview_cable
 * @author     Steve Groeber <steve.groeber@shd-online.de>
 * @copyright  2022 SHD System-Haus-Dresden GmbH
 * @license    http://www.i-doit.com/license
 */
class isys_cmdb_ui_category_g_smview_cable_virtual_route_element extends isys_cmdb_ui_category_g_smview_cable_route_element
{

    /**
     * Process the list.
     *
     * @param  isys_cmdb_dao_category $p_cat
     * @return null|void
     */
    public function process_list(isys_cmdb_dao_category &$p_cat, $p_get_param_override = null, $p_strVarName = null, $p_strTemplateName = null, $p_bCheckbox = true, $p_bOrderLink = true, $p_db_field_name = null)
    {
        parent::process_list($p_cat);
        $l_object_id = $p_cat->get_object_id() ?: $_GET[C__CMDB__GET__OBJECT];
        $url = isys_helper_link::get_base() . isys_helper_link::create_url(
            [
                C__CMDB__GET__OBJECT => $l_object_id,
                C__CMDB__GET__CATG   => defined_or_default('C__CATG__SMVIEW_CABLE_VIRTUAL_ROUTE'),
            ]
        );

        $this->get_template_component()->assign("redirect_url", $url);
    }

    /**
     * Fetches category's title from database.
     *
     * @param  isys_cmdb_dao_category &$p_cat Category's DAO
     * @return string  Category's title, otherwise error message.
     * @throws Exception
     */
    public function gui_get_title(isys_cmdb_dao_category &$p_cat)
    {
        $language = isys_application::instance()->container->get('language');
        $l_catdata = $p_cat->get_general_data();
        $description = $l_catdata['isys_catg_smview_cable_vir_route_list__description'];
        if (empty($description)) {
            return $language->get('LC__CMDB__CATG__SMVIEW_CABLE__VIRTUAL_ROUTE_CAT_TITLE');
        }
        return $language->get('LC__CMDB__CATG__SMVIEW_CABLE__VIRTUAL_ROUTE_CAT_TITLE') . ": $description";
    }
}
