<?php

/**
 * i-doit
 *
 * Module initializer
 *
 * @package i-doit
 * @subpackage smview_cable
 * @author Steve Groeber <steve.groeber@shd-online.de>
 * @copyright SHD System-Haus-Dresden GmbH
 * @license http://www.i-doit.com/license
 */

if (isys_module_manager::instance()->is_active('smview_cable')) {

    /* Initialize autoloader */
    if (include_once('isys_module_smview_cable_autoload.class.php')) {
        spl_autoload_register('isys_module_smview_cable_autoload::init');
    }

    \idoit\Psr4AutoloaderClass::factory()
            ->addNamespace('idoit\Module\smview_cable', __DIR__ . '/src/');

    /* Append custom module language file */
    global $g_idoit_language_short;

    $lang_path = __DIR__ . DS . 'lang' . DS . $g_idoit_language_short . '.inc.php';
    if (file_exists($lang_path)) {
        $l_language = include_once $lang_path;

        if (is_array($l_language)) {
            global $g_comp_template_language_manager;
            $g_comp_template_language_manager->append_lang($l_language);
        }
    }
    
    // Making the bsm controller class available
    $GLOBALS['g_controller']['handler']['smview_cable_test_data_generator'] = ['class' => 'isys_handler_smview_cable_test_data_generator'];
    $GLOBALS['g_controller']['handler']['smview_cable_cache_sync'] = ['class' => 'isys_handler_smview_cable_cache_sync'];

    // add signal to validate object title after category has been saved
    $signal = isys_application::instance()->container->get('signals');
    $signal->connect('mod.cmdb.afterCategoryEntrySave', ['idoit\Module\Cable\ObjectTitleValidator', 'validateAfterCategorySave']);

    // add signal to delete all section information if an object is purged
    $database = isys_application::instance()->container->get('database');
    $signal->connect('mod.cmdb.objectDeleted', [isys_cmdb_dao_category_g_smview_cable_section::instance($database), 'onObjectPurge']);
}
