<?php

/**
 * i-doit
 *
 * Popup for ETSI export.
 *
 * @package    i-doit
 * @subpackage smview_cable
 * @author     Steve Groeber <steve.groeber@shd-online.de>
 * @copyright  2020 SHD System-Haus-Dresden GmbH
 * @license    http://www.i-doit.com/license
 */
class isys_popup_smview_cable_etsi_export extends isys_component_popup
{

    /**
     * Handles Smarty inclusion.
     *
     * @param  isys_component_template $p_tplclass (unused)
     * @param  mixed                   $p_params   (unused)
     * @return string
     */
    public function handle_smarty_include(isys_component_template &$p_tplclass, $p_params)
    {
        // This is never used - the popup will directly be triggered via JS callback.
    }

    /**
     * Handles module request.
     *
     * @param  isys_module_request $p_modreq
     * @return isys_component_template
     */
    public function &handle_module_request(isys_module_request $p_modreq)
    {
        try {
            switch ($_POST['func']) {
                case 'single_export':
                    $export_id = $_POST['export_id'];
                    $export_dao = new isys_cmdb_dao_category_g_smview_cable_etsi_bay_export($this->database);
                    $export = $export_dao->get_data($export_id)->get_row();
                    $this->template->activate_editmode()
                        ->assign('is_single_export', true)
                        ->assign('title', $export['isys_obj__title'])
                        ->assign('export_id', $export_id)
                        ->display(isys_module_smview_cable::get_tpl_dir() . '/popup_etsi_export.tpl');
                    break;
                case 'export':
                    $exportIds = $_POST['id'] ? $_POST['id'] : null;
                    $exportId = $exportIds ? $exportIds[0] : null;
                    $export_dao = new isys_cmdb_dao_smview_cable_etsi_export($this->database);
                    $exports = $export_dao->get_objects();
                    $this->template->activate_editmode()
                                   ->assign('is_single_export', false)
                                   ->assign('exports', $exports)
                                   ->assign('export_id', $exportId)
                                   ->display(isys_module_smview_cable::get_tpl_dir() . '/popup_etsi_export.tpl');
                    break;
            }
            die;
        } catch (Exception $e) {
            $this->template->assign('error', $e->getMessage());
        }
        return $this->template;
    }
}
