<?php

/**
 * i-doit
 *
 * Popup for route export.
 *
 * @package    i-doit
 * @subpackage smview_cable
 * @author     Steve Groeber <steve.groeber@shd-online.de>
 * @copyright  2020 SHD System-Haus-Dresden GmbH
 * @license    http://www.i-doit.com/license
 */
class isys_popup_smview_cable_route_export extends isys_component_popup
{

    /**
     * Handles module request.
     *
     * @param  isys_module_request $p_modreq
     * @return isys_component_template
     */
    public function &handle_module_request(isys_module_request $p_modreq)
    {
        try {
            switch ($_POST['func']) {
                case 'export':
                    $routeDao = new isys_cmdb_dao_category_g_smview_cable_route($this->database);
                    $ids = $_POST['table_ids'];
                    $routes = [];
                    foreach ($ids as $id) {
                        $r = $routeDao->get_object_by_id($id)->get_row();
                        $routes[$r['isys_obj__id']] = $r['isys_obj__title'];
                    }

                    $routeIds = implode(',', $ids);
                    $this->template->activate_editmode()
                        ->assign('route_ids', $routeIds)
                        ->assign('routes', $routes)
                        ->display(isys_module_smview_cable::get_tpl_dir() . '/popup_route_export.tpl');
                    break;
            }
            die;
        } catch (Exception $e) {
            $this->template->assign('error', $e->getMessage());
        }
        return $this->template;
    }
}
