<?php

namespace idoit\Module\Cable\DependentObjectManager;

use isys_application;

/**
 * Admin Unit Manager class.
 *
 * @package    i-doit
 * @subpackage smview_cable
 * @author     Steve Groeber <steve.groeber@shd-online.de>
 * @copyright  SHD System-Haus-Dresden GmbH
 * @license    http://www.i-doit.com/license
 */
class AdminUnitManager extends AbstractManager
{
    
    /**
     * Property mapping.
     *
     * @var array
     */
    protected $_mapping = array(
        'description'    => 'C__CATG__SMVIEW_ADMIN_UNIT_DESCRIPTION',
        'classification' => 'C__CATG__SMVIEW_ADMIN_UNIT_CLASSIFICATION',
        'parent_id'      => 'C__CATG__SMVIEW_ADMIN_UNIT_PARENT',
    );
    
    /**
     * Constructor.
     */
    public function __construct()
    {
        $this->_dao = new \isys_cmdb_dao_smview_cable_admin_unit(\isys_application::instance()->database);
    }
    
    /**
     * Process generator listing.
     */
    public function processListing()
    {
        $lang = isys_application::instance()->container->get('language');
        $title = $lang->get('LC__CMDB__CATG__SMVIEW_CABLE__ADMIN_UNITS');
        $headers = [
            "id"              => "ID",
            "description"     => $lang->get('LC__CMDB__CATG__SMVIEW_CABLE__ADMIN_UNIT_DESCRIPTION'),
            "classification"  => $lang->get('LC__CMDB__CATG__SMVIEW_CABLE__ADMIN_UNIT_CLASSIFICATION')
        ];
        $this->_processListing($title, $headers);
    }
}
