<?php

namespace idoit\Module\Cable\DependentObjectManager;

use Exception;
use isys_application;
use isys_cmdb_dao_smview_cable_connection_type;

/**
 * Connection Type Manager class.
 *
 * @package    i-doit
 * @subpackage smview_cable
 * @author     Steve Groeber <steve.groeber@shd-online.de>
 * @copyright  SHD System-Haus-Dresden GmbH
 * @license    http://www.i-doit.com/license
 */
class ConnectionTypeManager extends AbstractManager
{
    
    /**
     * Property mapping.
     *
     * @var array
     */
    protected $_mapping = array(
        'name'        => 'C__CATG__SMVIEW_CABLE_NAME',
        'count'       => 'C__CATG__SMVIEW_CABLE_COUNT',
        'description' => 'C__CATG__SMVIEW_CABLE_DESCRIPTION',
    );
    
    /**
     * Constructor.
     */
    public function __construct()
    {
        $this->_dao = new isys_cmdb_dao_smview_cable_connection_type(\isys_application::instance()->database);
    }

    /**
     * Process generator listing.
     *
     * @throws Exception
     */
    public function processListing()
    {
        $lang = isys_application::instance()->container->get('language');
        $title = $lang->get('LC__CMDB__CATG__SMVIEW_CABLE__CABLE_CONNECTION_TYPES');
        $headers = [
            "id"    => "ID",
            "name"  => $lang->get('LC__CMDB__CATG__SMVIEW_CABLE__NAME'),
            "count" => $lang->get('LC__CMDB__CATG__SMVIEW_CABLE__COUNT'),
        ];
        $this->_processListing($title, $headers);
    }
}
