<?php

namespace idoit\Module\Cable\DependentObjectManager;

use isys_application;

/**
 * Technology Manager class.
 *
 * @package    i-doit
 * @subpackage smview_cable
 * @author     Steve Groeber <steve.groeber@shd-online.de>
 * @copyright  SHD System-Haus-Dresden GmbH
 * @license    http://www.i-doit.com/license
 */
class TechnologyManager extends AbstractManager
{
    
    /**
     * Property mapping.
     *
     * @var array
     */
    protected $_mapping = array(
        'description' => 'C__CATG__SMVIEW_CABLE_DESCRIPTION',
        'technology'  => 'C__CATG__SMVIEW_CABLE_TECHNOLOGY',
    );
    
    /**
     * Constructor.
     */
    public function __construct()
    {
        $this->_dao = new \isys_cmdb_dao_smview_cable_technology(\isys_application::instance()->database);
    }
    
    /**
     * Process technology listing.
     */
    public function processListing()
    {
        $lang = isys_application::instance()->container->get('language');
        $title = $lang->get('LC__CMDB__CATG__SMVIEW_CABLE__TECHNOLOGY');
        $headers = [
            "id"          => "ID",
            "description" => $lang->get('LC__CMDB__CATG__SMVIEW_CABLE__DESCRIPTION'),
            "technology"  => $lang->get('LC__CMDB__CATG__SMVIEW_CABLE__TECHNOLOGY'),
        ];
        $this->_processListing($title, $headers);
    }
}
