<?php

namespace idoit\Module\Cable\DependentObjectManager;

use isys_application;

/**
 * User State Manager class.
 *
 * @package    i-doit
 * @subpackage smview_cable
 * @author     Steve Groeber <steve.groeber@shd-online.de>
 * @copyright  SHD System-Haus-Dresden GmbH
 * @license    http://www.i-doit.com/license
 */
class UserStateManager extends AbstractManager
{
    
    /**
     * Property mapping.
     *
     * @var array
     */
    protected $_mapping = array(
        'name'        => 'C__CATG__SMVIEW_CABLE_NAME',
        'description' => 'C__CATG__SMVIEW_CABLE_DESCRIPTION',
    );
    
    /**
     * Constructor.
     */
    public function __construct()
    {
        $this->_dao = new \isys_cmdb_dao_smview_cable_user_state(\isys_application::instance()->database);
    }
    
    /**
     * Process generator listing.
     */
    public function processListing()
    {
        $lang = isys_application::instance()->container->get('language');
        $title = $lang->get('LC__CMDB__CATG__SMVIEW_CABLE__USER_STATE');
        $headers = [
            "id"          => "ID",
            "name"        => $lang->get('LC__CMDB__CATG__SMVIEW_CABLE__NAME'),
            "description" => $lang->get('LC__CMDB__CATG__SMVIEW_CABLE__DESCRIPTION')
        ];
        $this->_processListing($title, $headers);
    }
}
